//============================================================================
// ʒ`wb_
//
// (c)2021-2022 Micon-Giken
//============================================================================
#ifndef COMMON_H
#define	COMMON_H

//============================================================================
// `.
//============================================================================
// ^`.
typedef	unsigned char	uchar;
typedef	signed char		schar;
typedef	unsigned short	ushort;		// -> include\sys\types.hł`.
typedef	unsigned int	uint;		// -> include\sys\types.hł`.
typedef	unsigned long	ulong;		// -> include\sys\types.hł`.
typedef	unsigned long long ulonglong;

//----------------------------------------------------------------------------
// l`
#ifndef FALSE
#define FALSE	(0)
#endif

#ifndef TRUE
#define TRUE	(1)
#endif

#ifndef EOF
#define EOF		(-1)
#endif

#ifndef NULL
#define NULL	(0)
#endif

//============================================================================
// API֐.
//============================================================================
// CPU
#define __EI()		__enable_irq()		//asm("CPSIE i")Ɠ.
#define __DI()		__disable_irq()		//asm("CPSID i")Ɠ.
#define __halt()	asm("WFI")
#define __nop()		_nop()				//̂__builtin_nop()

//============================================================================
// ARMRApWX^}N.
//============================================================================
//------------------------------------------------------------------
// dݐ(NVIC)ݒiv:IRQԍ, x:Dx(L)j.
//		Cortex-M0+, M23: 0,64,128,192
//		Cortex-M4F     : 0,32,64,96,128,160,192,224
//------------------------------------------------------------------
//݋.
#define NVIC_enable_irq(v)		(NVIC->ISER[(v)>>5] = (1 << ((v) & 0x1f)))
//݋֎~.
#define NVIC_disable_irq(v)		(NVIC->ICER[(v)>>5] = (1 << ((v) & 0x1f)))
//݋Ԃ̔.
#define NVIC_enable_check(v)		(NVIC->ISER[(v)>>5] & (1 << ((v) & 0x1f)))
//ݗDxݒ.
#define NVIC_set_priority(v,x)	(NVIC->IP[(v)>>2] = (NVIC->IP[(v)>>2] & \
								 ~(0x0ff << (((v) & 0x3) * 8))) | ((x) << (((v) & 0x3) * 8)))
//ݗDx擾.
#define NVIC_get_priority(v)	((NVIC->IP[(v)>>2] >> (((v) & 0x3) * 8)) & 0xff)
//ݗv.
#define NVIC_set_irq(v)			(NVIC->ISPR[(v)>>5] = (1 << ((v) & 0x1f)))
//ݎ.
#define NVIC_clr_irq(v)			(NVIC->ICPR[(v)>>5] = (1 << ((v) & 0x1f)))

//============================================================================
// SAMV[Yp|[gWX^}N.
//============================================================================
//------------------------------------------------------------------
// |[go͐ݒip:_sԍAb:rbglAmap:Ӌ@\}bsOԍj.
//					  p: 0-63(PIN_PA00-31, PIN_PB00-31) 
//					  b: 0, 1
//					map: 0-n (device.henum PORT_MAPPING`Q).
//------------------------------------------------------------------
//lw肵āAo̓|[gɐݒ.
#define PORT_mode_out(p,b)	((b)?PORT_outset(p):PORT_outclr(p),\
							 PORT_REGS->GROUP[(p)>>5].PORT_DIRSET = 1 << ((p) & 0x1f))
//lw肵āAo̓|[gɐݒ.
#define PORT_mode_io(p,b)	((b)?PORT_outset(p):PORT_outclr(p),\
							 PORT_REGS->GROUP[(p)>>5].PORT_DIRSET = 1 << ((p) & 0x1f),\
							 PORT_REGS->GROUP[(p)>>5].PORT_PINCFG[((p) & 0x1f)] |= PORT_PINCFG_INEN(1))
//o͒[qnCp[ɐݒ(Lݒɒǉݒ).
#define PORT_mode_hpower(p)	(PORT_REGS->GROUP[(p)>>5].PORT_PINCFG[((p) & 0x1f)] |= 0x40)
//o͒[qm[}p[ɖ߂(Lݒɉꍇ).
#define PORT_mode_npower(p)	(PORT_REGS->GROUP[(p)>>5].PORT_PINCFG[((p) & 0x1f)] &= ~0x40)
//̓|[g(vAbv^_E)ɐݒ.
#define PORT_mode_in(p)		(PORT_REGS->GROUP[(p)>>5].PORT_DIRCLR = 1 << ((p) & 0x1f),\
							 PORT_REGS->GROUP[(p)>>5].PORT_PINCFG[((p) & 0x1f)] |= PORT_PINCFG_INEN(1))
//̓|[g(vAbv)ɐݒ.
#define PORT_mode_inpu(p)	(PORT_REGS->GROUP[(p)>>5].PORT_DIRCLR = 1 << ((p) & 0x1f),\
							 PORT_REGS->GROUP[(p)>>5].PORT_OUTSET = 1 << ((p) & 0x1f),\
							 PORT_REGS->GROUP[(p)>>5].PORT_PINCFG[((p) & 0x1f)] = 6)
//̓|[g(v_E)ɐݒ.
#define PORT_mode_inpd(p)	(PORT_REGS->GROUP[(p)>>5].PORT_DIRCLR = 1 << ((p) & 0x1f),\
							 PORT_REGS->GROUP[(p)>>5].PORT_OUTCLR = 1 << ((p) & 0x1f),\
							 PORT_REGS->GROUP[(p)>>5].PORT_PINCFG[((p) & 0x1f)] = 6)
//Ӌ@\}bsO.
#define PORT_peri(p,map)	(((p)&1)? (PORT_REGS->GROUP[(p)>>5].PORT_PMUX[((p) & 0x1f)>>1] |= PORT_PMUX_PMUXO(map)):\
									  (PORT_REGS->GROUP[(p)>>5].PORT_PMUX[((p) & 0x1f)>>1] |= PORT_PMUX_PMUXE(map)),\
									   PORT_REGS->GROUP[(p)>>5].PORT_PINCFG[((p) & 0x1f)] |= PORT_PINCFG_PMUXEN(1))
//Ӌ@\̃}bsO.
#define PORT_peri_off(p)	(((p)&1)? (PORT_REGS->GROUP[(p)>>5].PORT_PMUX[((p) & 0x1f)>>1] &= PORT_PMUX_PMUXO(~0)):\
									  (PORT_REGS->GROUP[(p)>>5].PORT_PMUX[((p) & 0x1f)>>1] &= PORT_PMUX_PMUXE(~0)),\
									   PORT_REGS->GROUP[(p)>>5].PORT_PINCFG[((p) & 0x1f)] &= ~PORT_PINCFG_PMUXEN(~0))
//|[gԂɖ߂.
#define PORT_mode_off(p)	(PORT_REGS->GROUP[(p)>>5].PORT_DIRCLR = 1 << ((p) & 0x1f),\
							 PORT_REGS->GROUP[(p)>>5].PORT_PINCFG[((p) & 0x1f)] = 0)

//------------------------------------------------------------------
// |[góA|[ǵip:_sԍAb:rbglAw:[hlj.
//					  p: 0-63(PIN_PA00-31, PIN_PB00-31) 
//					  b: 0, 1
//					  w: 0x00000000-0xFFFFFFFF
//------------------------------------------------------------------
//wso͂1ɂ.
#define PORT_outset(p)		(PORT_REGS->GROUP[(p)>>5].PORT_OUTSET = 1 << ((p) & 0x1f))
//wso͂0ɂ.
#define PORT_outclr(p)		(PORT_REGS->GROUP[(p)>>5].PORT_OUTCLR = 1 << ((p) & 0x1f))
//wso͂wrbglɂ.
#define PORT_outbit(p, b)	((b)?PORT_outset(p):PORT_outclr(p))
//w|[gO[vo͂w胏[hlɂ(p͑\sw).
#define PORT_outword(p, w)	(PORT_REGS->GROUP[(p)>>5].PORT_OUT = (w))
//wso͂̏Ԃ𔻒肷.
#define PORT_outchkbit(p)	(PORT_REGS->GROUP[(p)>>5].PORT_OUT & (1 << ((p) & 0x1f)))
//wso͂̃rbgl𓾂.
#define PORT_outgetbit(p)	((PORT_REGS->GROUP[(p)>>5].PORT_OUT >> ((p) & 0x1f)) & 1)

//ws͂̏Ԃ𔻒肷.
#define PORT_inchkbit(p)	(PORT_REGS->GROUP[(p)>>5].PORT_IN & (1 << ((p) & 0x1f)))
//ws͂̃rbgl𓾂.
#define PORT_ingetbit(p)	((PORT_REGS->GROUP[(p)>>5].PORT_IN >> ((p) & 0x1f)) & 1)
//wsO[v͂̃[hl𓾂(p͑\sw).
#define PORT_inword(p)		(PORT_REGS->GROUP[(p)>>5].PORT_IN)

//============================================================================
// SAMV[YpӋ@\WX^}N.
//============================================================================
//------------------------------------------------------------------
//	NbNE\[XZk`is:Zkj.
//						s: MPLABX񋟂gclk.hQ.
//------------------------------------------------------------------
#define	_src(s)				(GCLK_GENCTRL_SRC_##s##_Val)

//------------------------------------------------------------------
//	ėp({`) ig:WX^O[vAr:WX^Ab:rbgAval:ݒlj.
//------------------------------------------------------------------
#define _reg(g, r)		   (g##_REGS->g##_##r)
#define _bit(g, r, b)	   (g##_REGS->g##_##r & g##_##r##_##b##_Msk)
#define _val(g, r, b, val) ((val)<<g##_##r##_##b##_Pos)
#define _set(g, r, b, val) (g##_REGS->g##_##r |= (val)<<g##_##r##_##b##_Pos)
#define _put(g, r, b, val) (g##_REGS->g##_##r = (g##_REGS->g##_##r & \
							~(g##_##r##_##b##_Msk)) | ((val)<<g##_##r##_##b##_Pos))

//------------------------------------------------------------------
//	SERCOMpigs:WX^O[vAr:WX^Ab:rbgAval:ݒlj.
//			gs: SERCOMn_REGS->USART_INT, SPIM, I2CM
//------------------------------------------------------------------
//------------------------------------------------------------------
//	SERCOM(USART_INT)p.
#define _regSC(gs, r)		  (gs.SERCOM_##r)
#define _bitSC(gs, r, b)	  (gs.SERCOM_##r & SERCOM_USART_INT_##r##_##b##_Msk)
#define _valSC(gs, r, b, val) ((val)<<SERCOM_USART_INT_##r##_##b##_Pos)
#define _setSC(gs, r, b, val) (gs.SERCOM_##r |= (val)<<SERCOM_USART_INT_##r##_##b##_Pos)
#define _putSC(gs, r, b, val) (gs.SERCOM_##r = (gs.SERCOM_##r & \
								~(SERCOM_USART_INT_##r##_##b##_Msk)) | ((val)<<SERCOM_USART_INT_##r##_##b##_Pos))

//------------------------------------------------------------------
//	SERCOM(SPIM)p.
#define _regSP(gs, r)		  (gs.SERCOM_##r)
#define _bitSP(gs, r, b)	  (gs.SERCOM_##r & SERCOM_SPIM_##r##_##b##_Msk)
#define _valSP(gs, r, b, val) ((val)<<SERCOM_SPIM_##r##_##b##_Pos)
#define _setSP(gs, r, b, val) (gs.SERCOM_##r |= (val)<<SERCOM_SPIM_##r##_##b##_Pos)
#define _putSP(gs, r, b, val) (gs.SERCOM_##r = (gs.SERCOM_##r & \
								~(SERCOM_SPIM_##r##_##b##_Msk)) | ((val)<<SERCOM_SPIM_##r##_##b##_Pos))

//------------------------------------------------------------------
//	SERCOM(I2CM)p.
#define _regIM(gs, r)		  (gs.SERCOM_##r)
#define _bitIM(gs, r, b)	  (gs.SERCOM_##r & SERCOM_I2CM_##r##_##b##_Msk)
#define _valIM(gs, r, b, val) ((val)<<SERCOM_I2CM_##r##_##b##_Pos)
#define _setIM(gs, r, b, val) (gs.SERCOM_##r |= (val)<<SERCOM_I2CM_##r##_##b##_Pos)
#define _putIM(gs, r, b, val) (gs.SERCOM_##r = (gs.SERCOM_##r & \
								~(SERCOM_I2CM_##r##_##b##_Msk)) | ((val)<<SERCOM_I2CM_##r##_##b##_Pos))

//------------------------------------------------------------------
//	TCpigs:WX^O[vAr:WX^Ab:rbgAval:ݒlj.
//			gs: TCn_REGS->COUNT16
//------------------------------------------------------------------
#define _regTC(gs, r)		  (gs.TC_##r)
#define _bitTC(gs, r, b)	  (gs.TC_##r & TC_##r##_##b##_Msk)
#define _valTC(gs, r, b, val) ((val)<<TC_##r##_##b##_Pos)
#define _setTC(gs, r, b, val) (gs.TC_##r |= (val)<<TC_##r##_##b##_Pos)
#define _putTC(gs, r, b, val) (gs.TC_##r = (gs.TC_##r & \
								~(TC_##r##_##b##_Msk)) | ((val)<<TC_##r##_##b##_Pos))

//------------------------------------------------------------------
//	ADpig:WX^O[vAr:WX^Ab:rbgAval:ݒlj.
//			g: ADCn_REGS
//------------------------------------------------------------------
#define _regAD(g, r)		 (g->ADC_##r)
#define _bitAD(g, r, b)		 (g->ADC_##r & ADC_##r##_##b##_Msk)
#define _valAD(g, r, b, val) ((val)<<ADC_##r##_##b##_Pos)
#define _setAD(g, r, b, val) (g->ADC_##r |= (val)<<ADC_##r##_##b##_Pos)
#define _putAD(g, r, b, val) (g->ADC_##r = (g->ADC_##r & \
							  ~(ADC_##r##_##b##_Msk)) | ((val)<<ADC_##r##_##b##_Pos))

//------------------------------------------------------------------
//	CANpig:WX^O[vAr:WX^Ab:rbgAval:ݒlj.
//			g: CANn_REGS
//------------------------------------------------------------------
#define _regCAN(g, r)			(g->CAN_##r)
#define _bitCAN(g, r, b)		(g->CAN_##r & CAN_##r##_##b##_Msk)
#define _valCAN(g, r, b, val)	((val)<<CAN_##r##_##b##_Pos)
#define _setCAN(g, r, b, val)	(g->CAN_##r |= (val)<<CAN_##r##_##b##_Pos)
#define _putCAN(g, r, b, val)	(g->CAN_##r = (g->CAN_##r & \
								~(CAN_##r##_##b##_Msk)) | ((val)<<CAN_##r##_##b##_Pos))
#define _getCAN(g, r, b)		((g->CAN_##r & CAN_##r##_##b##_Msk)>>CAN_##r##_##b##_Pos)

//------------------------------------------------------------------
//	USBpig:WX^O[vAr:WX^Ab:rbgAval:ݒlj.
//			g: USB_REGS
//------------------------------------------------------------------
#define _regUSB(g, r)			(g->USB_##r)
#define _bitUSB(g, r, b)		(g->USB_##r & USB_##r##_##b##_Msk)
#define _valUSB(g, r, b, val)	((val)<<USB_##r##_##b##_Pos)
#define _setUSB(g, r, b, val)	(g->USB_##r |= (val)<<USB_##r##_##b##_Pos)
#define _putUSB(g, r, b, val)	(g->USB_##r = (g->USB_##r & \
								~(USB_##r##_##b##_Msk)) | ((val)<<USB_##r##_##b##_Pos))
#define _getUSB(g, r, b)		((g->USB_##r & USB_##r##_##b##_Msk)>>USB_##r##_##b##_Pos)

//============================================================================
#endif	/* COMMON_H */
