//============================================================================
// J[l
//
// (c)2019-2021 Micon-Giken
//============================================================================
#include "kernel.h"

//============================================================================
// `.
//============================================================================
// XPW[̑NAۗ.
#define wakeup_schedule()	(NVIC_set_irq(SCHEDULE_IRQ),\
							 NVIC_enable_irq(SCHEDULE_IRQ))
#define reserve_schedule()	(NVIC_enable_irq(SCHEDULE_IRQ))
#define sleep_schedule()	(NVIC_disable_irq(SCHEDULE_IRQ))
#define reffer_schedule()	(NVIC_enable_check(SCHEDULE_IRQ))
#define SYSTIME_CLOCKED		(1)						// .
#define SYSTIME_CLEARED		(0)						// 񏄉.
#define SYSTIME_ADDVALUE	(TASK_PERIOD * 1000)	// oߎԂsPʂŉZ.

#if BASE_FREQUENCY == 1000000
#define SYSTIME_RATIO		(0)
#elif BASE_FREQUENCY == 2000000
#define SYSTIME_RATIO		(1)
#elif BASE_FREQUENCY == 4000000
#define SYSTIME_RATIO		(2)
#elif BASE_FREQUENCY == 8000000
#define SYSTIME_RATIO		(3)
#elif BASE_FREQUENCY == 16000000
#define SYSTIME_RATIO		(4)
#else
#error wrong BASE_FREQUENCY
#endif
//============================================================================
// vg^Cv.
//============================================================================

//============================================================================
// f[^.
//============================================================================
TASK_TCB volatile TASK_tcb[TASK_NUMBER_MAX];//^XN(^XNւ̃|C^Cs).
TASK_TCB volatile *TASK_pt;					// s^XN̐ւ̃|C^.
TASK_FLAG volatile TASK_flag;				// ^XNǗtO.
ulonglong volatile systime;					// vZbT.

//============================================================================
// API֐.
//============================================================================
// J[l(J[l^C}N).
void KERNEL_init(void) {

	// ^C}ݒ.
#if (TARGET_BOARD & SAMD21_ALL)
	_reg(GCLK, CLKCTRL) =
			_val(GCLK, CLKCTRL, ID,  BTIMER_PCH)  |
			_val(GCLK, CLKCTRL, GEN, BTIMER_GCLK) |
			_val(GCLK, CLKCTRL, CLKEN, 1) ;
#else
	_reg(GCLK, PCHCTRL)[BTIMER_PCH] =
			_val(GCLK, PCHCTRL, GEN, BTIMER_GCLK) |
			_val(GCLK, PCHCTRL, CHEN, 1) ;
#endif
	BTIMER_APB_EN();									//oXNbNJn.
	
	_regTC(BTIMER_TC, CC)[0] = BTIMER_PERIOD;			//ݒ.
	_regTC(BTIMER_TC, CC)[1] = BTIMER_WINDOW;			//EChEݒ.
#if (TARGET_BOARD & SAMD21_ALL)
	_regTC(BTIMER_TC, CTRLA) =
			_valTC(BTIMER_TC, CTRLA, WAVEGEN, TC_CTRLA_WAVEGEN_MPWM_Val);	//샂[hݒ.
#else
	_regTC(BTIMER_TC, WAVE) = TC_WAVE_WAVEGEN_MPWM;		//샂[hݒ.
#endif
	_regTC(BTIMER_TC, INTFLAG)	= BTIMER_PERIOD_INT |
								  BTIMER_WINDOW_INT ;	//ÔߊݗvNA.
	_regTC(BTIMER_TC, INTENSET) = BTIMER_PERIOD_INT |
								  BTIMER_WINDOW_INT ;	//݋.
	NVIC_set_priority(BTIMER_IRQ, 128);					//Dxݒ.
	NVIC_enable_irq(BTIMER_IRQ);						//NVIC݋.

	//XPW[̃vCIeBу}XNCl[u.
	NVIC_set_priority(SCHEDULE_IRQ, 192);				//Dxݒ.
	NVIC_clr_irq(SCHEDULE_IRQ);							//NVICݗvNA.
	NVIC_enable_irq(SCHEDULE_IRQ);						//NVIC݋.
	_setTC(BTIMER_TC, CTRLA, ENABLE, 1);				//^C}Jn  1bito.

#if (TARGET_BOARD & SAME54_ALL)
    NVIC_SetPriorityGrouping( 0x04 );
#endif
    __DMB();
	__EI();												//CPU݋.
	return;
}

//----------------------------------------------------------------------------
// I[o[E^XNID擾.
int refer_error_task(void) {
	int c;
	c = TASK_flag.log - 1;
	TASK_flag.log = 0;
	return c;
}

//---------------------------------------------------------------------
// ԊǗAPI.
//---------------------------------------------------------------------
// oߎԂ̎擾 (58N).
ulonglong KERNEL_time_ll(void) {
	ushort i;
	ulonglong j;
	
	do {
		j = systime;
#if (TARGET_BOARD & SAMD21_ALL)
		_regTC(BTIMER_TC, READREQ) = 
				_valTC(BTIMER_TC, READREQ, RREQ, 1)	|
				_valTC(BTIMER_TC, READREQ, ADDR, 0x10)	;
		while (_bitTC(BTIMER_TC, STATUS, SYNCBUSY));
		/*^C}[h薢mF*/
#else
		_regTC(BTIMER_TC, CTRLBSET) = TC_CTRLBSET_CMD_READSYNC;
		while (_bitTC(BTIMER_TC, SYNCBUSY, CTRLB));
		while (_bitTC(BTIMER_TC, CTRLBSET, CMD));
		while (_bitTC(BTIMER_TC, SYNCBUSY, COUNT));
#endif
		i = _regTC(BTIMER_TC, COUNT);
	} while (j != systime);
	return j + (i >> SYSTIME_RATIO);
}
//---------------------------------------------------------------------
// oߎԂ̎擾@(71).
ulong KERNEL_time(void) {
	ushort i;
	ulong j;
	
	do {
		j = systime;
#if (TARGET_BOARD & SAMD21_ALL)
		_regTC(BTIMER_TC, READREQ) = 
				_valTC(BTIMER_TC, READREQ, RREQ, 1)	|
				_valTC(BTIMER_TC, READREQ, ADDR, 0x10)	;
		while (_bitTC(BTIMER_TC, STATUS, SYNCBUSY));
		/*^C}[h薢mF*/
#else
		_regTC(BTIMER_TC, CTRLBSET) = TC_CTRLBSET_CMD_READSYNC;
		while (_bitTC(BTIMER_TC, SYNCBUSY, CTRLB));
		while (_bitTC(BTIMER_TC, CTRLBSET, CMD));
		while (_bitTC(BTIMER_TC, SYNCBUSY, COUNT));
#endif
		i = _regTC(BTIMER_TC, COUNT);
	} while (j != (ulong)systime);
	return j + (i >> SYSTIME_RATIO);
}

//---------------------------------------------------------------------
// main֐Ŏ̏҂.
void KERNEL_wait_next_period(void) {
	uint i;
	i = systime;
	while (i == (uint)systime) {
		__halt();
	}
}

//============================================================================
// 又.
//============================================================================
// J[l(񐧌).
//#pragma interrupt kernel_schedule
__attribute__((interrupt))
void kernel_schedule(void) {

	__EI();			// d荞݋.

	//-----------------------------------------------------------------
	// ҂ԊǗ.
	//-----------------------------------------------------------------
	if (TASK_flag.systime == SYSTIME_CLOCKED) {
		TASK_flag.systime = SYSTIME_CLEARED;
		systime += SYSTIME_ADDVALUE;			// oߎԂ̃JEg.
		
		for (TASK_pt = TASK_tcb; TASK_pt < TASK_tcb + TASK_NUMBER_MAX; TASK_pt++) {
//			__DI();	// D抄荞݂wakeupƂ̊h~ dldelay_task^XNnhwakeup邱Ƃ֎~ƋL.
			if(TASK_pt->flags > TASK_DELAY) TASK_pt->flags--;
//			__EI();
		}
		//-----------------------------------------------------------------
		// EIb`hbOENA.
		//-----------------------------------------------------------------
		_reg(WDT, CLEAR) = WDT_CLEAR_CLEAR_KEY;
	}
	
	//-----------------------------------------------------------------
	// ^XŇĂяo.
	//-----------------------------------------------------------------
	for (TASK_pt = TASK_tcb; TASK_pt < TASK_tcb + TASK_NUMBER_MAX; TASK_pt++) {
		if (!reffer_schedule()) return;
		if (TASK_pt->flags == TASK_ACTIVE) {
			(TASK_pt->addr)();
		}
		if (TASK_flag.systime) {
			TASK_flag.log = (((char*) TASK_pt - (char*) TASK_tcb) >> 3) + 1;
			//I[o[^XN\-P邱.
			return;
		}
	}
}
//============================================================================
// [J֐.
//============================================================================

//============================================================================
// nh.
//============================================================================
// ^C}.
//#pragma interrupt kernel_timer
__attribute__((interrupt))
void kernel_timer(void) {
	__EI();			// d荞݋.
	
	if (_regTC(BTIMER_TC, INTFLAG) & BTIMER_WINDOW_INT) {
		_regTC(BTIMER_TC, INTFLAG) = BTIMER_WINDOW_INT;
		sleep_schedule();
	}
	else if (_regTC(BTIMER_TC, INTFLAG) & BTIMER_PERIOD_INT) {
		_regTC(BTIMER_TC, INTFLAG) = BTIMER_PERIOD_INT;
		TASK_flag.systime = SYSTIME_CLOCKED;
		wakeup_schedule();
	}
}

//============================================================================
