//============================================================================
// J[lpwb_
//
// (c)2021-2022 Micon-Giken
//============================================================================
#ifndef KERNEL_H
#define	KERNEL_H

#include "common.h"
#include "device.h"
#include "task.h"
#undef char
#undef short
#undef int
#undef long
#undef signed
#undef unsigned

//============================================================================
// `.
//============================================================================
// ^XN̏.
#define TASK_NONE		(0x00)		// o^.
#define TASK_WAIT		(0x01)		// Cxg҂i^XN̋N҂j.
#define TASK_ACTIVE		(0x02)		// s\.
#define TASK_DELAY		(0x02)		// {҂x[Xl.

// ^XNւ̃|C^^`(LXgp).
typedef void (*TASK_ADDR)(void);

// TCB\̒`.
typedef struct {
	TASK_ADDR	addr;				// ^XNւ̃|C^ .
	ushort		flags;				// ^XNԃtO.
	ushort		rfu;				// \.
} TASK_TCB;

//^XNǗtO\.
typedef struct {
	char	log;					// I[o[^XNԍL^p.
	uchar	systime;				// tO.
	uchar	rfu6;					// \.
	uchar	rfu7;					// \.
} TASK_FLAG;

//^XNǗϐ.
extern	TASK_TCB	volatile TASK_tcb[];	// TCB\̂̔z.
extern	TASK_TCB	volatile *TASK_pt;		// sTCBւ̃|C^.
extern	TASK_FLAG	volatile TASK_flag;		// ^XNǗtO.

// XPW[̗\.
#define reserve_schedule()		(NVIC_enable_irq(SCHEDULE_IRQ))

// xN̐؂グvZ⏕.
#define roundup_delay(t)		( (((t)<<4)/TASK_PERIOD + 15) >> 4)  

//============================================================================
// API֐.
//============================================================================

// ^XNǗp֐Qi}NŁj
// ^XN̓o^EJn.
#define start_task(id, funct)\
	(TASK_tcb[(id)].addr = (funct), TASK_tcb[(id)].flags = TASK_ACTIVE)

// ^XNN҂ɕύX.
#define suspend_task(id)		(TASK_tcb[(id)].flags = TASK_WAIT )

// ^XN̋N.
#define wakeup_task(id)\
	(TASK_tcb[(id)].flags = TASK_ACTIVE, reserve_schedule())

// ^XNԂ̎擾.
#define refer_task(id)			(TASK_tcb[(id)].flags)

// ^XN̑ČĂяoݒ.
#define		retry_task()\
	{TASK_pt->flags = TASK_ACTIVE; reserve_schedule(); return;}
#define set_retry_task()\
	(TASK_pt->flags = TASK_ACTIVE, reserve_schedule())

// ^XN̑҂ݒ(10ms).
#define delay_task(t)	{TASK_pt->flags = TASK_DELAY + roundup_delay(t); return;}
#define set_delay_task(t)		(TASK_pt->flags = TASK_DELAY + roundup_delay(t))

// ^XNN҂ɐݒ.
#define		sleep_task()		{TASK_pt->flags = TASK_WAIT; return;}
#define set_sleep_task()		(TASK_pt->flags = TASK_WAIT)

// ^XN̎s֐ݒ.
#define		next_task(funct)	{TASK_pt->addr = (funct); return;}
#define set_next_task(funct)	(TASK_pt->addr = (funct))

#define break_retry_task(funct) \
	{TASK_pt->addr = (funct);\
	TASK_pt->flags = TASK_ACTIVE; reserve_schedule(); return;\
	} }	 void funct (void) { /*extern int DUMMY_DUMMY*/
#define break_delay_task(funct, t) \
	{TASK_pt->addr = (funct);\
	TASK_pt->flags = TASK_DELAY + roundup_delay(t);   return;\
	} }	 void funct (void) { /*extern int DUMMY_DUMMY*/
#define break_task(funct) \
	{next_task(funct);\
	} }	 void funct (void) { /*extern int DUMMY_DUMMY*/

// ^XN̊Kwďo(X^bNݒAďoAA).
#define set_stack_task(depth) \
	static uchar	call_stack_DEPTH = (depth); \
	static uchar	call_stack_cnt; \
	static TASK_ADDR	call_stack_addr[depth];

#define call_task(call_funct, return_funct) \
	if (call_stack_cnt < call_stack_DEPTH) { \
		call_stack_addr[call_stack_cnt++] = return_funct;\
		next_task(call_funct); }

#define return_task() \
	if (call_stack_cnt > 0) { \
		next_task(call_stack_addr[--call_stack_cnt]); }

#define break_call_task(call_funct, return_funct) \
	if (call_stack_cnt < call_stack_DEPTH) { \
		call_stack_addr[call_stack_cnt++] = return_funct;\
		next_task(call_funct); \
	} }	 void return_funct (void) { /*extern int DUMMY_DUMMY*/

//----------------------------------------------------------------------------
// I[o[E^XNID擾i߂lIDԍ܂EOF(G[)j.
int refer_error_task(void);

//----------------------------------------------------------------------------
// J[l(J[l^C}N).
void		KERNEL_init(void);

//----------------------------------------------------------------------------
// ŇoߎԂ̎擾i߂l̓sPʁj.
ulonglong	KERNEL_time_ll(void);		// 58NB
ulong		KERNEL_time(void);			// L̉32bit(71).

//----------------------------------------------------------------------------
// main֐Ŏ̏҂i^XNł͎gp֎~j.
void		KERNEL_wait_next_period(void);

//============================================================================
#endif	/* KERNEL_H */
