//============================================================================
// AiOM̓^XN
//
// (c)2021 Micon-Giken
//============================================================================
#include "kernel.h"
#include "task_ad.h"

//============================================================================
// `.
//============================================================================
#ifndef AD_FCH_VOLM2
#define AD_FCH_VOLM2	(ADC_INPUTCTRL_MUXPOS_AIN7)
#endif
#ifndef AD_FCH_VOLM1
#define AD_FCH_VOLM1	(ADC_INPUTCTRL_MUXPOS_AIN6)
#endif
#ifndef AD_FCH_AUX2
#define AD_FCH_AUX2		(ADC_INPUTCTRL_MUXPOS_AIN5)
#endif
#ifndef AD_FCH_AUX1
#define AD_FCH_AUX1		(ADC_INPUTCTRL_MUXPOS_AIN4)
#endif

#if BASE_FREQUENCY == 1000000
#define AD_PRESCA		(0)
#elif BASE_FREQUENCY == 2000000
#define AD_PRESCA		(1)
#elif BASE_FREQUENCY == 4000000
#define AD_PRESCA		(2)
#elif BASE_FREQUENCY == 8000000
#define AD_PRESCA		(3)
#elif BASE_FREQUENCY == 16000000
#define AD_PRESCA		(4)
#else
#error wrong BASE_FREQUENCY
#endif

enum AD_STATUS {
	AD_STATUS_BUSY,
	AD_STATUS_READY,
};

//============================================================================
// vg^Cv.
//============================================================================
void AD_main(void);						// AD^XN(又).

//============================================================================
// f[^.
//============================================================================
static volatile int AD_flag;								//ԃtO.
static volatile int AD_cnt;									//ړσJE^.
static volatile uint AD_in_data[AD_NUMBER][AD_AVENUM];
static volatile uint AD_out_data[AD_NUMBER];
static const uchar AD_fch_table[AD_NUMBER] = {
	AD_FCH_VOLM1 
#if AD_NUMBER > 1
	,AD_FCH_VOLM2
#if AD_NUMBER > 2
	,AD_FCH_AUX1
#if AD_NUMBER > 3
	,AD_FCH_AUX2
#if AD_NUMBER > 4
	,AD_FCH_LIST
#endif
#endif
#endif
#endif
};

//============================================================================
// API֐.
//============================================================================
// hCo[`
void AD_init(void) {
	uint z, zc, wk_reg;
	
	//NbNnݒ
#if (TARGET_BOARD & SAMD21_ALL)
	_reg(GCLK, CLKCTRL) =
			_val(GCLK, CLKCTRL, ID, AD_PCH) |
			_val(GCLK, CLKCTRL, GEN, AD_GCLK) |
			_val(GCLK, CLKCTRL, CLKEN, 1) ;
#else
	_reg(GCLK, PCHCTRL)[AD_PCH] =
			_val(GCLK, PCHCTRL, GEN, AD_GCLK) |
			_val(GCLK, PCHCTRL, CHEN, 1) ;
#endif
	AD_APB_EN();
	
	//------------------------------------------------------------------------
	// ADCLu[VݒioXNbNECl[uɐݒj.
	//------------------------------------------------------------------------
	// Lu[VEf[^擾.
#if (TARGET_BOARD & SAMD21_ALL)
	wk_reg = *(ulong*) 0x806020 >> 27;		//Lu[VEf[^ǂݍ.

	z = _bitAD(AD_AD, CALIB, LINEARITY_CAL) | 
		_bitAD(AD_AD, CALIB, BIAS_CAL);		//Lu[VݒlmF.
	zc = _valAD(AD_AD, CALIB, LINEARITY_CAL, wk_reg & 0x0ff) |
		 _valAD(AD_AD, CALIB, BIAS_CAL, (wk_reg >> 8) & 0x07);	//ݒ肷ׂf[^.
	if (z != zc) {
		_regAD(AD_AD, CALIB) = zc;				//Lu[VXV.
		//while(1);
	}
	
#elif (TARGET_BOARD & SAMC21_ALL)
	wk_reg = *(uint*) 0x806020;		//Lu[VEf[^ǂݍ.

	z = _bitAD(AD_AD, CALIB, BIASCOMP) | 
		_bitAD(AD_AD, CALIB, BIASREFBUF);		//Lu[VݒlmF.
	zc = _valAD(AD_AD, CALIB, BIASCOMP, wk_reg & 0x07) |
		 _valAD(AD_AD, CALIB, BIASREFBUF, (wk_reg >> 3) & 0x07);		//ݒ肷ׂf[^.
	if (z != zc) {
		_regAD(AD_AD, CALIB) = zc;				//Lu[VXV.
		//while(1);
	}
	
#ifdef AD1_PCH
	z = _bitAD(AD_AD1, CALIB, BIASCOMP) | 
		_bitAD(AD_AD1, CALIB, BIASREFBUF);		//Lu[VݒlmF.
	zc = _valAD(AD_AD1, CALIB, BIASCOMP, (wk_reg >> 6) & 0x07) |
		 _valAD(AD_AD1, CALIB, BIASREFBUF, (wk_reg >> 9) & 0x07);		//ݒ肷ׂf[^.
	if (z != zc) {
		_regAD(AD_AD1, CALIB) = zc;				//Lu[VXV.
		//while(1);
	}
#endif
#elif (TARGET_BOARD & SAME54_ALL)
	wk_reg = *(uint*) 0x800080;		//Lu[VEf[^ǂݍ.
	z = _regAD(AD_AD, CALIB) & 0x777;
	zc = _valAD(AD_AD, CALIB, BIASCOMP,   (wk_reg >> 16) & 0x07) |
		 _valAD(AD_AD, CALIB, BIASREFBUF, (wk_reg >> 19) & 0x07) |
		 _valAD(AD_AD, CALIB, BIASR2R,    (wk_reg >> 22) & 0x07);
	if (z != zc) {
		_regAD(AD_AD, CALIB) = zc;				//Lu[VXV.
		//while(1);
	}
	
#ifdef AD0_PCH
	z = _regAD(AD_AD0, CALIB) & 0x777;
	zc = _valAD(AD_AD0, CALIB, BIASCOMP,   (wk_reg >> 2) & 0x07) |
		 _valAD(AD_AD0, CALIB, BIASREFBUF, (wk_reg >> 5) & 0x07) |
		 _valAD(AD_AD0, CALIB, BIASR2R,    (wk_reg >> 8) & 0x07);
	if (z != zc) {
		_regAD(AD_AD0, CALIB) = zc;				//Lu[VXV.
		//while(1);
	}
#endif
#endif
	
	//ADCݒ
#if (TARGET_BOARD & SAMD21_ALL)
	_regAD(AD_AD, REFCTRL) = ADC_REFCTRL_REFCOMP(1) |
							 ADC_REFCTRL_REFSEL_INTVCC1;
	
#elif (TARGET_BOARD & SAMC21_ALL)
	_regAD(AD_AD, REFCTRL) = ADC_REFCTRL_REFSEL_INTVCC2;
	_setAD(AD_AD, CTRLC, R2R, 1);				//[to[   1bito.
	_setAD(AD_AD, SAMPCTRL, OFFCOMP, 1);		//1bito.
#elif (TARGET_BOARD & SAME54_ALL)
	_regAD(AD_AD, REFCTRL) = ADC_REFCTRL_REFSEL_INTVCC1;
//	_setAD(AD_AD, CTRLA, R2R, 1);				//[to[(̂).
	_setAD(AD_AD, CTRLA, PRESCALER, AD_PRESCA);	//vXP[.
	_setAD(AD_AD, SAMPCTRL, OFFCOMP, 1);		//1bito.
#endif
	_regAD(AD_AD, INTENSET) = AD_RESRDY_INT;	//荞ݗLɂȂƃtOȂ.
	_setAD(AD_AD, CTRLA, ENABLE, 1);			//ADCLɂ  1bito.
	start_task(AD_taskid, AD_main);
}

//---------------------------------------------------------------------
// AiO͒l擾.
uint AD_value(uint ch) {
	if (AD_flag == AD_STATUS_READY && ch < AD_NUMBER) {
		return AD_out_data[ch];
	}
	return 0;
}

//============================================================================
// ^XNA又.
//============================================================================
// AD^XN(又).
void AD_main() {
	int i;
	
	//*** MUXNEGw肵ȂėǂmF̂***.
	for (i = 0; i < AD_NUMBER; i++) {
		if (AD_flag == AD_STATUS_READY) AD_out_data[i] -= AD_in_data[i][AD_cnt];

#if (TARGET_BOARD & SAMD21_ALL)
		_regAD(AD_AD, INPUTCTRL) = AD_fch_table[i] |		//|[gI.
				ADC_INPUTCTRL_GAIN_DIV2 |					//Gain=1/2.
				ADC_INPUTCTRL_MUXNEG_GND;					//MUXNEGw.
		while(_bitAD(AD_AD, STATUS, SYNCBUSY));
#else
		_regAD(AD_AD, INPUTCTRL) = AD_fch_table[i];			//|[gI.
		while(_bitAD(AD_AD, SYNCBUSY, INPUTCTRL));
#endif

		_regAD(AD_AD, INTFLAG) = AD_RESRDY_INT;				//tOENA.
		while(_bitAD(AD_AD, INTFLAG, RESRDY));
		_setAD(AD_AD, SWTRIG, START, 1);					//ADCϊJn	 1bito.
		while(!_bitAD(AD_AD, INTFLAG, RESRDY));				//҂.
		AD_out_data[i] += (AD_in_data[i][AD_cnt] = _regAD(AD_AD, RESULT));
	}
	if (++AD_cnt >= AD_AVENUM) {
		AD_cnt = 0;
		AD_flag = AD_STATUS_READY;
	}
	
	delay_task(AD_PERIOD);
}

//============================================================================
// [J֐.
//============================================================================

//============================================================================
// nh.
//============================================================================

//============================================================================
