//============================================================================
// uU[i`gójAfBt^XN
//
// (c)2021 Micon-Giken
//============================================================================
#include "kernel.h"
#include "task_beep.h"

//============================================================================
// `.
//============================================================================
#define BEEP_ONKAI_MIN	42
#define BEEP_ONKAI_MAX	127

//============================================================================
// vg^Cv.
//============================================================================
void BEEP_main(void);						// BEEP^XN(又).
void BEEP_set(void);						// fB.
void BEEP_timer_start(ushort c);			// `go͂̊Jn/ĊJ.
void BEEP_timer_pause(void);				// `go͂̈ꎞ~.
void BEEP_timer_stop(void);					// `go͂̒~.

//============================================================================
// f[^.
//============================================================================
static struct {
	int status;					// Xe[^X.
	int count;					// ԃJEg.
	int period;					// .
} BEEP_ctrl;
#define BEEP_status BEEP_ctrl.status
#define BEEP_count	BEEP_ctrl.count
#define BEEP_period BEEP_ctrl.period

#define nHYOSHI	9
int				BEEP_hyoshi[nHYOSHI];
ONPU			*BEEP_base;
int				BEEP_rp;
int				BEEP_ichou;
int				BEEP_quiet = 4;
uint			BEEP_time;			// Jn.
uint			BEEP_time_note;		// .
uint			BEEP_time_quiet;	// .
int				BEEP_repcnt[4];		// s[gJE^.
#define BEEP_ADDR(x)	(( *(ushort*)&x >> 1) & 0x7ff)
#define BEEP_RESTART	(mREPLAY_CMD)
#define BEEP_FINISH		(mFINISH_CMD)

const ushort BEEP_onkai[] = {
																   64865, 61224, 57788,
	54544, 51483, 48593, 45866, 43292, 40862, 38568, 36404, 34360, 32432, 30612, 28893,
	27272, 25741, 24296, 22933, 21645, 20430, 19284, 18201, 17180, 16215, 15305, 14446,
	13635, 12870, 12148, 11466, 10822, 10215,  9641,  9100,	 8589,	8107,  7652,  7223,
	 6817,	6435,  6073,  5732,	 5411,	5107,  4820,  4550,	 4294,	4053,  3826,  3611,
	 3408,	3217,  3036,  2866,	 2705,	2553,  2410,  2274,	 2147,	2026,  1912,  1805,
	 1704,	1608,  1518,  1432,	 1352,	1276,  1204,  1137,	 1073,	1013,	956,   902,
	  851,	 803,	758,   716,	  675,	 637,	602,   568,	  536,	 506,	477
};

//============================================================================
// API֐.
//============================================================================
// hCo[`
void BEEP_init(void) {

	//|[gݒ(͓dȂ)
	PORT_mode_out(BEEP_PIN, 0);

	//ӗpNbNAoXNbNݒ
#if (TARGET_BOARD & SAMD21_ALL)
	_reg(GCLK, CLKCTRL) =
			_val(GCLK, CLKCTRL, ID,  BEEP_PCH)  |
			_val(GCLK, CLKCTRL, GEN, BEEP_GCLK) |
			_val(GCLK, CLKCTRL, CLKEN, 1) ;
#else
	_reg(GCLK, PCHCTRL)[BEEP_PCH] =
			_val(GCLK, PCHCTRL, GEN, BEEP_GCLK) |
			_val(GCLK, PCHCTRL, CHEN, 1) ;
#endif
	BEEP_APB_EN();								//oXNbNJn

	// ^C}ݒ.
#if (TARGET_BOARD & SAMD21_ALL)
	_regTC(BEEP_TC, CTRLA) =
			_valTC(BEEP_TC, CTRLA, WAVEGEN, TC_CTRLA_WAVEGEN_MFRQ_Val);	//샂[hݒ.
#else
	_putTC(BEEP_TC, CTRLA, MODE, 0);
	_regTC(BEEP_TC, WAVE) = TC_WAVE_WAVEGEN_MFRQ;
#endif

	start_task(BEEP_taskid, BEEP_main);
}

//---------------------------------------------------------------------
// BEEPw.
void BEEP_out(int freq, int time) {
	BEEP_period = BEEP_FREQUENCY / freq / 2;	//Zo
	BEEP_count	= time;							//󂯎Ԃ
	BEEP_status = BEEP_REQUEST;					//N
	wakeup_task(BEEP_taskid);
}

//---------------------------------------------------------------------
// tv.
int	BEEP_play(ONPU *p, int offset, int tempo, int ichou) {

	if (BEEP_status) return EOF;
	BEEP_base = p;
	BEEP_rp = offset;
	BEEP_ichou = ichou;
	BEEP_hyoshi[T3L] = (4000 / tempo + 1) * 10000 / 2;		// 3A̒(sP).
	BEEP_hyoshi[T16] = (3000 / tempo + 1) * 10000 / 2;		// 16̒(sP).
	BEEP_hyoshi[T8]	 = BEEP_hyoshi[T16] + BEEP_hyoshi[T16];
	BEEP_hyoshi[T8T] = BEEP_hyoshi[T8]	+ BEEP_hyoshi[T16];
	BEEP_hyoshi[T4]	 = BEEP_hyoshi[T8T] + BEEP_hyoshi[T16];
	BEEP_hyoshi[T4T] = BEEP_hyoshi[T4]	+ BEEP_hyoshi[T8];
	BEEP_hyoshi[T2]	 = BEEP_hyoshi[T4T] + BEEP_hyoshi[T8];
	BEEP_hyoshi[T2T] = BEEP_hyoshi[T2]	+ BEEP_hyoshi[T4];
	BEEP_hyoshi[T1]	 = BEEP_hyoshi[T2T] + BEEP_hyoshi[T4];

	BEEP_status = BEEP_START;
	wakeup_task(BEEP_taskid);
	return 0;
}

//---------------------------------------------------------------------
// t~.
int	BEEP_stop(void) {
	if (!BEEP_status) return EOF;
	BEEP_status = BEEP_STOP;
	wakeup_task(BEEP_taskid);
	return BEEP_rp;
}

//---------------------------------------------------------------------
// Xe[^X擾.
int BEEP_refer(void) {
	return BEEP_status;
}

//============================================================================
// ^XNA又.
//============================================================================
// BEEP^XN(又).
void BEEP_main(void) {
	
	if (BEEP_status == BEEP_REQUEST && BEEP_count > 0) {
		_regTC(BEEP_TC, CC)[0] = BEEP_period - 1;			//CC0ɑ
		_setTC(BEEP_TC, CTRLA, ENABLE, 1);
		PORT_peri(BEEP_PIN, BEEP_MAPPING);
		BEEP_status = BEEP_ONGOING;
	}
	else if (BEEP_status == BEEP_ONGOING) {
		if (BEEP_count <= 0) {
			BEEP_status = BEEP_IDLE;
			_putTC(BEEP_TC, CTRLA, ENABLE, 0);
			PORT_peri_off(BEEP_PIN);
		}
		else BEEP_count--;
	}
	else if (BEEP_status == BEEP_IDLE) {
		sleep_task();
	}
	else if (BEEP_status == BEEP_START) {
		BEEP_time = KERNEL_time();					// Jnݒ.
		BEEP_set();
	}
	else if (BEEP_status == BEEP_NOTE) {
		// ԊĎ.
		if ( KERNEL_time() - BEEP_time >= BEEP_time_note) {
			BEEP_time += BEEP_time_note;
			if (BEEP_time_quiet) {
				BEEP_timer_pause();
				BEEP_status = BEEP_QUIET;
			}
			else {
				BEEP_rp++;
				BEEP_set();
			}
		}
	}
	else if (BEEP_status == BEEP_QUIET) {
		// ԊĎ.
		if ( KERNEL_time() - BEEP_time >= BEEP_time_quiet) {
			BEEP_time += BEEP_time_quiet;
			BEEP_rp++;
			BEEP_set();
		}
	}
	else if (BEEP_status == BEEP_STOP) {
		BEEP_timer_stop();
		BEEP_status = BEEP_IDLE;
	}
	
	delay_task(10);
}

//============================================================================
// [J֐.
//============================================================================
// fB.
void BEEP_set(void) {
	uint i, j;
	
	while (1) {
		i = BEEP_base[BEEP_rp].cut;

		if (!BEEP_base[BEEP_rp].sys) {	/************* KR[h ***********/
			if (i == QFF) {
				BEEP_timer_pause();
				BEEP_time_quiet = BEEP_hyoshi[ BEEP_base[BEEP_rp].time ];
				BEEP_status = BEEP_QUIET;
			}
			else {
				// ^C}ݒlvZA
				j = BEEP_base[BEEP_rp].note + BEEP_ichou;
				if (j < BEEP_ONKAI_MIN) j = BEEP_ONKAI_MIN;
				else if (j > BEEP_ONKAI_MAX) j = BEEP_ONKAI_MAX;
				j -= BEEP_ONKAI_MIN;
				BEEP_timer_start( BEEP_onkai[j]);

				// ,ԌvZ
				BEEP_time_note = BEEP_hyoshi[ BEEP_base[BEEP_rp].time ];
				if		(i == 0) BEEP_time_quiet = BEEP_quiet;
				else if (i < 5 ) BEEP_time_quiet = (i - 1) * 2;
				else			 BEEP_time_quiet = (i - 4) * (BEEP_time_note / 10);
				BEEP_time_note -= BEEP_time_quiet;
				BEEP_status = BEEP_NOTE;
			}
			return;
		}
		else {	/************************* R[h ***********************/
			if (i == BEEP_RESTART ) {		// X^[g.
				BEEP_rp = 0;
			}
			else if (i == BEEP_FINISH ) {	// I.
				BEEP_timer_stop();
				BEEP_status = BEEP_IDLE;
				return;
			}
			else if (i < 4) {						// JE^Zbg.
				BEEP_repcnt[i] = BEEP_base[BEEP_rp++].note;
			}
			else if ((i -= 4) < 4) {				// ߂萧.
				if (BEEP_repcnt[i]) {
					BEEP_repcnt[i]--;
					BEEP_rp = BEEP_ADDR( BEEP_base[BEEP_rp] );
				}
				else BEEP_rp++;
			}
			else if ((i -= 4) < 4) {				// iݐ.
				if (BEEP_repcnt[i]) {
					BEEP_repcnt[i]--;
					BEEP_rp++;
				}
				else BEEP_rp = BEEP_ADDR( BEEP_base[BEEP_rp] );
			}
		}
	}
}
// `go͂̊Jn/ĊJ.
void BEEP_timer_start(ushort c) {
	_regTC(BEEP_TC, CC)[0] = c;
	_setTC(BEEP_TC, CTRLA, ENABLE, 1);
	PORT_peri(BEEP_PIN, BEEP_MAPPING);
}

// `go͂̈ꎞ~.
void BEEP_timer_pause(void) {
	PORT_peri_off(BEEP_PIN);
}

// `go͂̒~.
void BEEP_timer_stop(void) {
	_putTC(BEEP_TC, CTRLA, ENABLE, 0);
	PORT_peri_off(BEEP_PIN);
}

//============================================================================
// nh.
//============================================================================

//============================================================================
