//============================================================================
// p[^Ǘ^XN
//
// (c)2021 Micon-Giken
//============================================================================
#include "kernel.h"
#include "task_eep.h"

//============================================================================
// `.
//============================================================================
#if 1							//foCXɂI
#define EEP_READY_FLAG			_bit(NVMCTRL, INTFLAG, READY)		//SAMC2x
#define EEP_CMD_ERASE			0xa51a		// f[^eraseR}h
#define EEP_CMD_WRITE			0xa51c		// f[^writeR}h
#else
#define EEP_READY_FLAG			_bit(NVMCTRL, STATUS, READY)		//SAML1x
#define EEP_CMD_ERASE			0xa502		// f[^eraseR}h
#define EEP_CMD_WRITE			0xa504		// f[^writeR}h
#endif
#define EEP_TOTAL_SIZE			2048		// EEP̈TCY.
#define EEP_ROW_SIZE			256
#define EEP_PAGE_SIZE			64
#define EEP_DATA_SIZE	sizeof(EEP_DATA)	// p[^ubNTCY
#define EEP_CHECK_SIZE			256			// p[^ubNmFTCY
#define EEP_START_NUM			1
#define EEP_BASE_ADDR	(0x400000)			// EEP̈x[XAhX

//============================================================================
// vg^Cv.
//============================================================================
void EEP_main(void);						// ^XN(v҂)
void EEP_load_task(void);					// ^XN(load)
void EEP_erase_task(void);					// ^XN()
void EEP_save_task(void);					// ^XN(save)

//============================================================================
// f[^.
//============================================================================
EEP_DATA		eep_data;
static short	index_tmp;
static short	next_addr;
static short	work_addr;
static uchar	status;			//ݏ.

static const EEP_DATA init_data = {
	EEP_START_NUM, ~EEP_START_NUM,
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 

	{0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0}
};

//============================================================================
// API֐.
//============================================================================
// hCo[`
void EEP_init(void) {
	if (EEP_DATA_SIZE == EEP_CHECK_SIZE) {
//		_reg(NVMCTRL, INTENSET) = _val(NVMCTRL, INTENSET, READY, 1);	//sv
		eep_data = init_data;
		status = EEP_STATUS_LOAD;
		next_addr = 0;
		start_task(EEP_taskid, EEP_main);
	}
	else while(1);
}

//---------------------------------------------------------------------
int EEP_load(void) {			// p[^ǂݍ.
	if (status != EEP_STATUS_READY)	return status;
	status = EEP_STATUS_LOAD;
	wakeup_task(EEP_taskid);
	return EEP_STATUS_ACCEPT;
}

//---------------------------------------------------------------------
int EEP_save(void) {			// p[^ۑ.
	if (status != EEP_STATUS_READY &&
		status != EEP_STATUS_WERROR)	return status;
	status = EEP_STATUS_SAVE;
	wakeup_task(EEP_taskid);
	return EEP_STATUS_ACCEPT;
}

//---------------------------------------------------------------------
int EEP_status(void) {			// p[^^ۑ̊mF.
	return status;
}
//============================================================================
// ^XNA又.
//============================================================================
// EEP^XN(又).
void EEP_main(void) {
	long *ps, i, j;
	
	if (status == EEP_STATUS_LOAD) {
		set_retry_task();
		next_task(EEP_load_task);
	}
	else if (status == EEP_STATUS_SAVE) {
		//NVMp[[hύX(Ô)
		_set(NVMCTRL, CTRLB, SLEEPPRM, NVMCTRL_CTRLB_SLEEPPRM_DISABLED_Val);
		index_tmp = eep_data.index;
		eep_data.index = index_tmp + 1;
		eep_data.index_v = ~eep_data.index;
		
		work_addr = 0;
		if (next_addr % EEP_ROW_SIZE == 0) {
			//uN`FbN
			ps = (long*)(EEP_BASE_ADDR + next_addr);
			i = ~0;
			for (j = 0; j < EEP_ROW_SIZE; j += 4) {
				i &= *ps++;
				if (i != ~0) break;
			}
			//
			if (i != ~0) {
				set_retry_task();
				next_task(EEP_erase_task);
			}
		}
		set_retry_task();
		next_task(EEP_save_task);
	}
	sleep_task();
}

//---------------------------------------------------------------------
// ^XN(load)
void EEP_load_task(void) {	
	short	*pt;
	long	*ps, *pd, i;
	
	pt = (short*)(EEP_BASE_ADDR + next_addr);
	if (pt[0] == ~pt[1] &&
		(eep_data.index == EEP_START_NUM || pt[0] == eep_data.index + 1)) {
			eep_data.index = pt[0];
			next_addr += EEP_DATA_SIZE;
			if (next_addr >= EEP_TOTAL_SIZE) next_addr = 0;
	}
	else {
		if (eep_data.index == EEP_START_NUM) eep_data = init_data;
		else {
			eep_data.index_v = ~eep_data.index;
			pd = (long*)&eep_data + 1;
			if (next_addr == 0) ps = (long*)(EEP_BASE_ADDR + EEP_TOTAL_SIZE - EEP_DATA_SIZE + 4);
			else				ps = (long*)(EEP_BASE_ADDR + next_addr      - EEP_DATA_SIZE + 4);
			i = EEP_DATA_SIZE >> 2;
			while (--i > 0) *pd++ = *ps++;
		}
		status = EEP_STATUS_READY;
		next_task(EEP_main);
	}
	retry_task();
}

//---------------------------------------------------------------------
void EEP_erase_task(void) {					// ^XN()

	if (EEP_READY_FLAG == 0) {
		retry_task();
	}
	if (work_addr < EEP_DATA_SIZE) {
//		_reg(NVMCTRL, ADDR) = EEP_BASE_ADDR + next_addr + work_addr;	//0x400100C[XłȂ => n[t[hPʂŎw肪Kv
		*(long*)(EEP_BASE_ADDR + next_addr + work_addr) = 0;			//SAMC2x,L1xǂłg͂
		_reg(NVMCTRL, CTRLA) = EEP_CMD_ERASE;
		work_addr += EEP_ROW_SIZE;
		retry_task();
	}
	work_addr = 0;
	set_retry_task();
	next_task(EEP_save_task);
}

//---------------------------------------------------------------------
void EEP_save_task(void) {					// ^XN(save)
	long	*pd, *ps, i;
	
	if (EEP_READY_FLAG == 0) {
		retry_task();
	}
	if (work_addr < EEP_DATA_SIZE) {
		ps = (long*)&eep_data + (work_addr >> 2);
		pd = (long*)(EEP_BASE_ADDR + next_addr + work_addr);
		for (i = 0; i < EEP_PAGE_SIZE; i += 4) *pd++ = *ps++;
		_reg(NVMCTRL, CTRLA) = EEP_CMD_WRITE;
		work_addr += EEP_PAGE_SIZE;
		retry_task();
	}
	
	//NVMp[[hύX
	_put(NVMCTRL, CTRLB, SLEEPPRM, NVMCTRL_CTRLB_SLEEPPRM_WAKEONACCESS_Val);		// lɖ߂.
	
	//xt@C
	ps = (long*)&eep_data;
	pd = (long*)(EEP_BASE_ADDR + next_addr);
	for (i = 0; i < EEP_DATA_SIZE; i +=4) {
		if (*pd++ != *ps++) {
			eep_data.index = index_tmp;
			eep_data.index_v = ~eep_data.index;
			status = EEP_STATUS_WERROR;
			next_task(EEP_main);
		}
	}

	//Z[u
	next_addr += EEP_DATA_SIZE;
	if (next_addr >= EEP_TOTAL_SIZE) next_addr = 0;
	status = EEP_STATUS_READY;
	next_task(EEP_main);
}

//============================================================================
// [J֐.
//============================================================================

//============================================================================
// nh.
//============================================================================

//============================================================================
