//============================================================================
// p[^Ǘ^XN(I2C)
//
// (c)2021 Micon-Giken
//============================================================================
#include "kernel.h"
#include "task_eep_i2c.h"

//============================================================================
// `.
//============================================================================
#if 0
#if 1							//foCXɂI
#define EEP_READY_FLAG			_bit(NVMCTRL, INTFLAG, READY)		//SAMC2x
#define EEP_CMD_ERASE			0xa51a		// f[^eraseR}h
#define EEP_CMD_WRITE			0xa51c		// f[^writeR}h
#else
#define EEP_READY_FLAG			_bit(NVMCTRL, STATUS, READY)		//SAML1x
#define EEP_CMD_ERASE			0xa502		// f[^eraseR}h
#define EEP_CMD_WRITE			0xa504		// f[^writeR}h
#endif
#define EEP_TOTAL_SIZE			2048		// EEP̈TCY.
#define EEP_ROW_SIZE			256
#define EEP_PAGE_SIZE			64
#define EEP_BASE_ADDR	(0x400000)			// EEP̈x[XAhX
#endif

#define EEP_TOTAL_SIZE			131072		// EEP̈TCY.
#define EEP_DATA_SIZE	sizeof(EEP_DATA)	// p[^ubNTCY
#define EEP_CHECK_SIZE			256			// p[^ubNmFTCY
#define EEP_PAGE_SIZE			256			// EEPy[WTCY.
#define EEP_START_NUM			0x69A5		// .indexl

#define I2C_READ				1
#define I2C_WRITE				0
#define I2C_MIN_tRISE			70		// ŏオ莞(vAbv+eʂɈˑ) [ns].
#define I2C_MAX_FREQUENCY		400000	// őNbNg [Hz].
#define I2C_tHIGH_RATIO			1		// NbNHigh Ԕ䗦(KiKl).
#define I2C_tLOW_RATIO			2		// NbNLow Ԕ䗦(KiKl).
#define I2C_BASE_ADDR			0x50	// IIICx[XAhX(7bit) An[q̎w荞.
#define I2C_CLK_ADD				5		// SAML̃{[[gZl.

//============================================================================
// vg^Cv.
//============================================================================
void EEP_main(void);						// ^XN(v҂).
void EEP_load_task(void);					// ^XN(load).
void EEP_save_task(void);					// ^XN(save).
void EEP_save2_task(void);				// ^XN(save)IIC݃Tu.
void EEP_save3_task(void);				// ^XN(save)IIC݃Tu.
void EEP_read2_task(void);				// ^XN I2C f[^ǂݏo(Tu).

//void EEP_read_task(void);					// ^XN(read).
//void EEP_write_task(void);				// ^XN(write).
//void EEP_write2_task(void);				// ^XNI2C f[^.
//void EEP_wait_task(void);					// ^XN(݊҂).

void I2C_start_addr(uchar rw);			//I2C AhX.
void I2C_write(void);						//I2C f[^.
void I2C_read(void);						//I2C f[^ǂݏo.
void I2C_stop(void);						//I2C XgbvRfBV쐬.

//============================================================================
// f[^.
//============================================================================
EEP_DATA		eep_data;
static uchar	status;			//ݏ.

static const EEP_DATA init_data = {
	EEP_START_NUM, ~EEP_START_NUM,
	{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 

	{0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0}
};

static uint  EEP_cnt;						// f[^JEg.
static uint  EEP_addr;						// EEPROMAhX.
static char* EEP_buff;						// f[^Eobt@̃|C^.
static char  EEP_cycle;
static char  EEP_page;						// p[^ݎ̃y[WJEg.

//============================================================================
// API֐.
//============================================================================
// hCo[`
void EEP_init(void) {
	if (EEP_DATA_SIZE == EEP_CHECK_SIZE) {
		//ӗpNbNAoXNbNݒ.
#if (TARGET_BOARD & SAMD21_ALL)
		_reg(GCLK, CLKCTRL) =
				_val(GCLK, CLKCTRL, ID, I2C_PCH) |
				_val(GCLK, CLKCTRL, GEN, I2C_GCLK) |
				_val(GCLK, CLKCTRL, CLKEN, 1) ;
#else
	_reg(GCLK, PCHCTRL)[I2C_PCH] =
			_val(GCLK, PCHCTRL, GEN, I2C_GCLK) |
			_val(GCLK, PCHCTRL, CHEN, 1) ;
#endif
		I2C_APB_EN();										//oXNbNJn.

		//|[gݒ.
		PORT_peri(I2C_SDA_PIN, I2C_MAPPING);
		PORT_peri(I2C_SCL_PIN, I2C_MAPPING);

		//I2Cݒ ({[[gvZ/100́AvZrł̃I[o[t[΍).
		#define	I2C_TOTAL_CK	((UART_FREQUENCY / (I2C_MAX_FREQUENCY / 100) + 99) / 100)
		#define I2C_CK_RISE		(((UART_FREQUENCY / 1000) * I2C_MIN_tRISE) / 1000000 + 1)
		#define I2C_CKL			(I2C_TOTAL_CK * I2C_tLOW_RATIO / (I2C_tLOW_RATIO + I2C_tHIGH_RATIO))
		#define I2C_CKH			(I2C_TOTAL_CK - I2C_CKL - I2C_CLK_ADD)
		_regIM(I2C_IM, BAUD) =
				_valIM(I2C_IM, BAUD, BAUD, I2C_CKH)	|
				_valIM(I2C_IM, BAUD, BAUDLOW, I2C_CKL - I2C_CK_RISE - I2C_CLK_ADD);
		_regIM(I2C_IM, CTRLA) =
				_valIM(I2C_IM, CTRLA, MODE, 0x05) ;		//I2C}X^[h.
		_setIM(I2C_IM, CTRLA, ENABLE, 1);				//Jn.
		while (_bitIM(I2C_IM, SYNCBUSY, ENABLE));

		_setIM(I2C_IM, STATUS, BUSSTATE, 0x01);			//oXXe[g.
		while (_bitIM(I2C_IM, SYNCBUSY, SYSOP));
		
		_regIM(I2C_IM, INTENSET) =
			I2C_MB_INT		|							//M.
			I2C_SB_INT		|							//f.
			I2C_ERROR_INT	;							//G[.

		I2C_stop();
		
		status = EEP_STATUS_LOAD;
		start_task(EEP_taskid, EEP_main);
	}
	else while(1);
}

//---------------------------------------------------------------------
int EEP_load(void) {			// p[^ǂݍ.
	if (status != EEP_STATUS_READY)	return status;
	status = EEP_STATUS_LOAD;
	wakeup_task(EEP_taskid);
	return EEP_STATUS_ACCEPT;
}

//---------------------------------------------------------------------
int EEP_save(void) {			// p[^ۑ.
	if (status != EEP_STATUS_READY &&
		status != EEP_STATUS_WERROR)	return status;
	status = EEP_STATUS_SAVE;
	wakeup_task(EEP_taskid);
	return EEP_STATUS_ACCEPT;
}

//---------------------------------------------------------------------
int EEP_status(void) {			// p[^^ۑ̊mF.
	return status;
}

//============================================================================
// ^XNA又.
//============================================================================
// EEP^XN(又).
void EEP_main(void) {
	
	switch(status) {
		case EEP_STATUS_LOAD:
			set_retry_task();
			next_task(EEP_load_task);
		case EEP_STATUS_SAVE:
			set_retry_task();
			next_task(EEP_save_task);
	}
	sleep_task();
}

//---------------------------------------------------------------------
// ^XN(load).
void EEP_load_task(void) {	
	EEP_buff = (char *)&eep_data;
	EEP_addr = 0;
	I2C_start_addr(I2C_READ);
	EEP_cnt = 8;
	I2C_read();
	
	if (eep_data.index != EEP_START_NUM || 
		eep_data.index != ~eep_data.index_v) {
		I2C_stop();
		eep_data = init_data;
		status = EEP_STATUS_READY;
		next_task(EEP_main);
	}

	EEP_cycle = (EEP_DATA_SIZE - 8) / 8;
	set_retry_task();
	next_task(EEP_read2_task);
}

//---------------------------------------------------------------------
void EEP_read2_task(void) {
	if (EEP_cycle-- == 0) {
		I2C_stop();
		status = EEP_STATUS_READY;
		next_task(EEP_main);
	}
	
	EEP_cnt = 8;
	I2C_read();
	retry_task();
}

//---------------------------------------------------------------------
void EEP_save_task(void) {					// ^XN(save)
	EEP_buff = (char *)&eep_data;
	EEP_addr = 0;
	
	EEP_page = EEP_DATA_SIZE / EEP_PAGE_SIZE;
	set_retry_task();
	next_task(EEP_save2_task);
}

void EEP_save2_task(void) {
	if (EEP_page-- == 0) {
		status = EEP_STATUS_READY;
		next_task(EEP_main);
	}

	I2C_start_addr(I2C_WRITE);
	EEP_cycle = EEP_PAGE_SIZE / 8;
	set_retry_task();
	next_task(EEP_save3_task);
}

void EEP_save3_task(void) {
	if (EEP_cycle-- == 0) {
		I2C_stop();
		EEP_addr += EEP_PAGE_SIZE;
		set_delay_task(10);
		next_task(EEP_save2_task);
	}
	
	EEP_cnt = 8;
	I2C_write();
	retry_task();
}

//============================================================================
// [J֐.
//============================================================================
//IIC AhX.
void I2C_start_addr(uchar rw) {
	uchar c;
	
	c = I2C_BASE_ADDR << 1;
	if (EEP_addr & (1 << 16)) c+= 2;
	if (EEP_addr & (1 << 17)) c+= 4;
	if (EEP_addr & (1 << 18)) c+= 8;
#if 0
	_regIM(I2C_IM, INTFLAG) =
			I2C_MB_INT		|							//M.
			I2C_SB_INT		|							//f.
			I2C_ERROR_INT	;							//G[.
#endif
	_regIM(I2C_IM, ADDR) = c;
	while (!_bitIM(I2C_IM, INTFLAG, MB));
#if 0
	//Ƃ́AERRORtO.
	if (_bitIM(I2C_IM, INTFLAG, ERROR)) {
		EEP_addr = _regIM(I2C_IM, STATUS);
	}
#endif
#if 0	
	_regIM(I2C_IM, INTFLAG) =
			I2C_MB_INT		|							//M.
			I2C_SB_INT		|							//f.
			I2C_ERROR_INT	;							//G[.
#endif
	_regIM(I2C_IM, DATA) = EEP_addr >> 8;
	while (!_bitIM(I2C_IM, INTFLAG, MB));
	//Ƃ́AERRORtO.
#if 0
	_regIM(I2C_IM, INTFLAG) =
			I2C_MB_INT		|							//M.
			I2C_SB_INT		|							//f.
			I2C_ERROR_INT	;							//G[.
#endif
	_regIM(I2C_IM, DATA) = EEP_addr;
	while (!_bitIM(I2C_IM, INTFLAG, MB));
	//Ƃ́AERRORtO.
	
	if (rw == I2C_READ)	{
#if 0
		_regIM(I2C_IM, INTFLAG) =
				I2C_MB_INT		|							//M.
				I2C_SB_INT		|							//f.
				I2C_ERROR_INT	;							//G[.
#endif
		_regIM(I2C_IM, ADDR) = c + 1;
		while (!_bitIM(I2C_IM, INTFLAG, SB));
		//Ƃ́AERRORtO.
	}
};

//IIC f[^.
void I2C_write(void) {
	while (EEP_cnt-- > 0) {
#if 0
		_regIM(I2C_IM, INTFLAG) =
				I2C_MB_INT		|							//M.
				I2C_SB_INT		|							//f.
				I2C_ERROR_INT	;							//G[.
#endif
		_regIM(I2C_IM, DATA) = *EEP_buff++;
		while (!_bitIM(I2C_IM, INTFLAG, MB));
		//Ƃ́AERRORtO.
	}
}

//IIC f[^ǂݏo.
void I2C_read(void) {
	while (EEP_cnt-- > 0) {
		*EEP_buff++ = _regIM(I2C_IM, DATA);
#if 0
		_regIM(I2C_IM, INTFLAG) =
				I2C_MB_INT		|							//M.
				I2C_SB_INT		|							//f.
				I2C_ERROR_INT	;							//G[.
#endif
		_regIM(I2C_IM, CTRLB) =
				_valIM(I2C_IM, CTRLB, CMD, 0x2);			// readR}h.
		while (!_bitIM(I2C_IM, INTFLAG, SB));
		//Ƃ́AERRORtO.
	}
}

//IIC XgbvRfBV쐬.
void I2C_stop(void) {
#if 0
	_regIM(I2C_IM, INTFLAG) =
			I2C_MB_INT		|							//M.
			I2C_SB_INT		|							//f.
			I2C_ERROR_INT	;							//G[.
#endif
	_regIM(I2C_IM, CTRLB) =
			_valIM(I2C_IM, CTRLB, CMD, 0x3);			// stopR}h.
	while (_bitIM(I2C_IM, SYNCBUSY, SYSOP));
}

//============================================================================
// nh.
//============================================================================

//============================================================================
