//============================================================================
// I2C^XN(EEPANZXt)
//
// (c)2022 Micon-Giken
//============================================================================
#include "kernel.h"
#include "task_i2c.h"

//============================================================================
// `.
//============================================================================
#define I2C_MIN_tRISE			70		// ŏオ莞(vAbv+eʂɈˑ) [ns].
#define I2C_MAX_FREQUENCY		400000	// őNbNg [Hz].
#define I2C_tHIGH_RATIO			1		// NbNHigh Ԕ䗦(KiKl).
#define I2C_tLOW_RATIO			2		// NbNLow Ԕ䗦(KiKl).
#define I2C_CLK_ADD				5		// SAML̃{[[gZl.

//============================================================================
// vg^Cv.
//============================================================================
void I2C_main(void);						// ^XN(R}h҂).
void I2C_init2(void);						// ^XN(Jn).
#if (TARGET_BOARD & SAMC21_CAN5)
void I2C_init3(void);						// ^XN(Jn).
#endif
void I2C_write_task(void);
void I2C_read_task(void);
void I2C_stop_task(void);					//I2C XgbvRfBV쐬.
void I2C_stop2_task(void);                  //I2C Xgbv҂.
void I2C_finish_task(void);
void I2C_EEP_write_task(void);
void I2C_EEP_write2_task(void);
void I2C_EEP_read_task(void);
void I2C_EEP_read2_task(void);
void I2C_EEP_read3_task(void);
void I2C_EEP_read4_task(void);
void I2C_EEP_addr_task(void);
void I2C_EEP_addr2_task(void);

//============================================================================
// f[^.
//============================================================================
static uchar	status;						//ݏ.
static char	 I2C_EEP_addr_buff[2];			// EEPROMAhX(Mp).
set_stack_task(1);							// Tu[`pX^bN.
static int   I2C_num;						// f[^].
static int	 I2C_cnt;						// f[^]JEg.
static int   I2C_addr;						// I2CAhX.
static char* I2C_buff;						// f[^Eobt@̃|C^.
static int   I2C_EEP_num;					// EEPROMf[^JEg.
static int   I2C_EEP_addr;					// EEPROMAhX.
static char* I2C_EEP_buff;					// EEPROMf[^Eobt@̃|C^.

//============================================================================
// API֐.
//============================================================================
// hCo[`
void I2C_init(void) {
	start_task(I2C_taskid, I2C_init2);
}

//---------------------------------------------------------------------
int I2C_write(int addr, char *buff, int num) {			// f[^݊Jn.
	if (status != I2C_STATUS_READY &&
		status != I2C_STATUS_WERROR)	return status;
	I2C_addr = addr;
	I2C_buff = buff;
	I2C_num = num;
	status = I2C_STATUS_WRITE;
	wakeup_task(I2C_taskid);
	return I2C_STATUS_ACCEPT;
}

//---------------------------------------------------------------------
int I2C_read(int addr, char *buff, int num) {			// f[^ǏoJn.
	if (status != I2C_STATUS_READY)	return status;
	I2C_addr = addr;
	I2C_buff = buff;
	I2C_num = num;
	status = I2C_STATUS_READ;
	wakeup_task(I2C_taskid);
	return I2C_STATUS_ACCEPT;
}

//---------------------------------------------------------------------
int I2C_status(void) {			// R}h̊mF.
	return status;
}

//---------------------------------------------------------------------
int I2C_EEP_write(int addr, char *buff, int num) {			// f[^݊Jn.
	if (status != I2C_STATUS_READY &&
		status != I2C_STATUS_WERROR)	return status;
	I2C_EEP_addr = addr;
	I2C_EEP_buff = buff;
	I2C_EEP_num = num;
	status = I2C_EEP_WRITE;
	wakeup_task(I2C_taskid);
	return I2C_STATUS_ACCEPT;
}

//---------------------------------------------------------------------
int I2C_EEP_read(int addr, char *buff, int num) {			// f[^ǏoJn.
	if (status != I2C_STATUS_READY)	return status;
	I2C_EEP_addr = addr;
	I2C_EEP_buff = buff;
	I2C_EEP_num = num;
	status = I2C_EEP_READ;
	wakeup_task(I2C_taskid);
	return I2C_STATUS_ACCEPT;
}

//============================================================================
// ^XNA又.
//============================================================================
// ^XN.
void I2C_init2(void) {
	
#if (TARGET_BOARD & SAMC21_CAN5)
	break_delay_task(I2C_init3, 500);
#endif
	
		//ӗpNbNAoXNbNݒ.
#if (TARGET_BOARD & SAMD21_ALL)
		_reg(GCLK, CLKCTRL) =
				_val(GCLK, CLKCTRL, ID, I2C_PCH) |
				_val(GCLK, CLKCTRL, GEN, I2C_GCLK) |
				_val(GCLK, CLKCTRL, CLKEN, 1) ;
#else
	_reg(GCLK, PCHCTRL)[I2C_PCH] =
			_val(GCLK, PCHCTRL, GEN, I2C_GCLK) |
			_val(GCLK, PCHCTRL, CHEN, 1) ;
#endif
		I2C_APB_EN();										//oXNbNJn.

		//|[gݒ.
//        PORT_mode_in(I2C_SDA_PIN);              //fobOp.
		PORT_peri(I2C_SDA_PIN, I2C_MAPPING);
		PORT_peri(I2C_SCL_PIN, I2C_MAPPING);

		//I2Cݒ ({[[gvZ/100́AvZrł̃I[o[t[΍).
		#define	I2C_TOTAL_CK	((UART_FREQUENCY / (I2C_MAX_FREQUENCY / 100) + 99) / 100)
		#define I2C_CK_RISE		(((UART_FREQUENCY / 1000) * I2C_MIN_tRISE) / 1000000 + 1)
		#define I2C_CKL			(I2C_TOTAL_CK * I2C_tLOW_RATIO / (I2C_tLOW_RATIO + I2C_tHIGH_RATIO))
		#define I2C_CKH			(I2C_TOTAL_CK - I2C_CKL - I2C_CLK_ADD)
		_regIM(I2C_IM, BAUD) =
				_valIM(I2C_IM, BAUD, BAUD, I2C_CKH)	|
				_valIM(I2C_IM, BAUD, BAUDLOW, I2C_CKL - I2C_CK_RISE - I2C_CLK_ADD);
		_regIM(I2C_IM, CTRLA) =
				_valIM(I2C_IM, CTRLA, MODE, 0x05) ;		//I2C}X^[h.
		_setIM(I2C_IM, CTRLA, ENABLE, 1);				//Jn.
		while (_bitIM(I2C_IM, SYNCBUSY, ENABLE));

		_setIM(I2C_IM, STATUS, BUSSTATE, 0x01);			//oXXe[g.
		while (_bitIM(I2C_IM, SYNCBUSY, SYSOP));
		
#ifdef I2C_IRQ
	NVIC_set_priority(I2C_IRQ, 64);						//NVICDx64.
	NVIC_enable_irq(I2C_IRQ);							//NVICCl[u.
#else
	NVIC_set_priority(I2C_SB_IRQ, 64);					//NVICDx64.
	NVIC_enable_irq(I2C_SB_IRQ);						//NVICCl[u.
	NVIC_set_priority(I2C_MB_IRQ, 128);					//NVICDx128.
	NVIC_enable_irq(I2C_MB_IRQ);						//NVICCl[u.
#endif
	
//		_regIM(I2C_IM, INTENSET) =
//			I2C_MB_INT		|							//M.
//			I2C_SB_INT		|							//M.
//			I2C_ERROR_INT	;							//G[.

		call_task(I2C_stop_task, I2C_finish_task);
}

//---------------------------------------------------------------------
// ^XN(R}h).
void I2C_main(void) {
	
	set_sleep_task();
	switch(status) {
		case I2C_STATUS_WRITE:
			_regIM(I2C_IM, ADDR) = I2C_addr << 1;
			I2C_cnt = 0;
			_regIM(I2C_IM, INTENSET) = I2C_MB_INT;			//M.
			call_task(I2C_stop_task, I2C_finish_task);
		case I2C_STATUS_READ:
			_regIM(I2C_IM, ADDR) = (I2C_addr << 1) + 1;
			I2C_cnt = 0;
			_regIM(I2C_IM, INTENSET) = I2C_SB_INT;			//M.
			call_task(I2C_stop_task, I2C_finish_task);
		case I2C_EEP_WRITE:
			set_retry_task();
			next_task(I2C_EEP_write_task);
		case I2C_EEP_READ:
			set_retry_task();
			next_task(I2C_EEP_read_task);
	}
}

//---------------------------------------------------------------------
//IIC XgbvRfBV쐬.
void I2C_stop_task(void) {
	_regIM(I2C_IM, CTRLB) =
			_valIM(I2C_IM, CTRLB, CMD, 0x3);			// stopR}h.
	
	break_retry_task(I2C_stop2_task);
	if (_bitIM(I2C_IM, SYNCBUSY, SYSOP)) retry_task();
	set_delay_task(5);
	return_task();
}

// R}hI.
void I2C_finish_task(void) {
	status = I2C_STATUS_READY;
	next_task(I2C_main);
}

//---------------------------------------------------------------------
// EEP AhXݒ^XN.
void I2C_EEP_addr_task(void) {

	set_sleep_task();
    I2C_addr = I2C_ADDR_EEPROM << 1;
	if (I2C_EEP_addr & (1 << 16)) I2C_addr += 2;
	if (I2C_EEP_addr & (1 << 17)) I2C_addr += 4;
	if (I2C_EEP_addr & (1 << 18)) I2C_addr += 8;
	
	I2C_EEP_addr_buff[0] = I2C_EEP_addr >> 8;
	I2C_EEP_addr_buff[1] = I2C_EEP_addr;
	I2C_buff = I2C_EEP_addr_buff;
	I2C_num = 2;
	I2C_cnt = 0;
	_regIM(I2C_IM, ADDR) = I2C_addr;
	_regIM(I2C_IM, INTENSET) = I2C_MB_INT;			//M.
	
	break_task(I2C_EEP_addr2_task);
    I2C_buff = I2C_EEP_buff;
    if (status == I2C_EEP_WRITE)
        	I2C_num = I2C_PAGE_SIZE - (I2C_EEP_addr & (I2C_PAGE_SIZE - 1));
    else    I2C_num = I2C_EEP_num;
    
    if (I2C_num > I2C_EEP_num) I2C_num = I2C_EEP_num;
    I2C_EEP_num -= I2C_num;
    I2C_EEP_addr += I2C_num;
    I2C_EEP_buff += I2C_num;
	I2C_cnt = 0;

	set_retry_task();
	return_task();
}

//---------------------------------------------------------------------
// ^XN(EEPROMCg).
void I2C_EEP_write_task(void) {
	
	set_retry_task();
	if (I2C_EEP_num <= 0) {
		next_task(I2C_finish_task);
	}
	
	break_call_task(I2C_EEP_addr_task, I2C_EEP_write2_task);
	
	set_sleep_task();
	I2C_cnt++;
	_regIM(I2C_IM, DATA) = *I2C_buff++;
	_regIM(I2C_IM, INTENSET) = I2C_MB_INT;			//M.
	
	call_task(I2C_stop_task, I2C_EEP_write_task);
}

//---------------------------------------------------------------------
// ^XN(EEPROM[h).
void I2C_EEP_read_task(void) {
	
	set_retry_task();
	if (I2C_EEP_num <= 0) {
		next_task(I2C_finish_task);
	}
	
	break_call_task(I2C_EEP_addr_task, I2C_EEP_read2_task);
	set_sleep_task();
	_regIM(I2C_IM, ADDR) = I2C_addr + 1;
	_regIM(I2C_IM, INTENSET) = I2C_SB_INT;      		//M.
	
    break_task(I2C_EEP_read3_task);
	_regIM(I2C_IM, CTRLB) =
                    _valIM(I2C_IM, CTRLB, ACKACT, 1) |  // NAK.
					_valIM(I2C_IM, CTRLB, CMD, 0x3);	// stopR}h.
    
	break_retry_task(I2C_EEP_read4_task);
	if (_bitIM(I2C_IM, SYNCBUSY, SYSOP)) retry_task();
    _putIM(I2C_IM, CTRLB, ACKACT, 0);
    set_retry_task();
    next_task(I2C_EEP_read_task);
}


//============================================================================
// [J֐.
//============================================================================


//============================================================================
// nh.
//============================================================================
#ifdef I2C_Handler
__attribute__((interrupt))
void I2C_Handler(void) {

	if (_regIM(I2C_IM, INTFLAG) & I2C_SB_INT) {
		_regIM(I2C_IM, INTFLAG) = I2C_SB_INT;
		*I2C_buff++ = _regIM(I2C_IM, DATA);
		if (++I2C_cnt < I2C_num) {
			_regIM(I2C_IM, CTRLB) =
					_valIM(I2C_IM, CTRLB, CMD, 0x2);		// readR}h.
		}
		else {
			_regIM(I2C_IM, INTENCLR) = I2C_SB_INT;
			wakeup_task(I2C_taskid);
		}
	}
	else {
		_regIM(I2C_IM, INTFLAG) = I2C_MB_INT;
		if (I2C_cnt < I2C_num) { 
			_regIM(I2C_IM, DATA) = *I2C_buff++;
			I2C_cnt++;
		}
		else {
			_regIM(I2C_IM, INTENCLR) = I2C_MB_INT;
			wakeup_task(I2C_taskid);
		}
	}
}
#else
__attribute__((interrupt))
void I2C_SB_Handler(void) {

	_regIM(I2C_IM, INTFLAG) = I2C_SB_INT;
	*I2C_buff++ = _regIM(I2C_IM, DATA);
	if (++I2C_cnt < I2C_num) {
		_regIM(I2C_IM, CTRLB) =
				_valIM(I2C_IM, CTRLB, CMD, 0x2);		// readR}h.
	}
	else {
		_regIM(I2C_IM, INTENCLR) = I2C_SB_INT;
		wakeup_task(I2C_taskid);
	}
}

__attribute__((interrupt))
void I2C_MB_Handler(void) {
	
	_regIM(I2C_IM, INTFLAG) = I2C_MB_INT;
	if (I2C_cnt < I2C_num) { 
		_regIM(I2C_IM, DATA) = *I2C_buff++;
		I2C_cnt++;
	}
	else {
		_regIM(I2C_IM, INTENCLR) = I2C_MB_INT;
		wakeup_task(I2C_taskid);
	}
}
#endif

//============================================================================
