//============================================================================
// PWMo͗phCo
//
// (c)2021-2022 Micon-Giken
//============================================================================
#include "kernel.h"
#include "task_pwm.h"

//============================================================================
// `.
//============================================================================
#if (TARGET_BOARD & SAMC21_ALL)
	#if   PWM_FREQUENCY == BEEP_FREQUENCY
	#define PWM_PREC  0
	#elif PWM_FREQUENCY == BEEP_FREQUENCY / 2
	#define PWM_PREC  1
	#elif PWM_FREQUENCY == BEEP_FREQUENCY / 4
	#define PWM_PREC  2
	#elif PWM_FREQUENCY == BEEP_FREQUENCY / 8
	#define PWM_PREC  3
	#elif PWM_FREQUENCY == BEEP_FREQUENCY / 16
	#define PWM_PREC  4
	#elif PWM_FREQUENCY == BEEP_FREQUENCY / 64
	#define PWM_PREC  5
	#elif PWM_FREQUENCY == BEEP_FREQUENCY / 256
	#define PWM_PREC  6
	#elif PWM_FREQUENCY == BEEP_FREQUENCY / 1024
	#define PWM_PREC  7
	#else
	#error
	#endif
#else
	#if   PWM_FREQUENCY == USB_FREQUENCY
	#define PWM_PREC  0
	#elif PWM_FREQUENCY == USB_FREQUENCY / 2
	#define PWM_PREC  1
	#elif PWM_FREQUENCY == USB_FREQUENCY / 4
	#define PWM_PREC  2
	#elif PWM_FREQUENCY == USB_FREQUENCY / 8
	#define PWM_PREC  3
	#elif PWM_FREQUENCY == USB_FREQUENCY / 16
	#define PWM_PREC  4
	#elif PWM_FREQUENCY == USB_FREQUENCY / 64
	#define PWM_PREC  5
	#elif PWM_FREQUENCY == USB_FREQUENCY / 256
	#define PWM_PREC  6
	#elif PWM_FREQUENCY == USB_FREQUENCY / 1024
	#define PWM_PREC  7
	#else
	#error
	#endif
#endif

//============================================================================
// vg^Cv.
//============================================================================

//============================================================================
// f[^.
//============================================================================
static int		count_max;
static schar	invert;

//============================================================================
// API֐.
//============================================================================
// PWMhCo.
void PWM_init(void) {
	//ӗpNbNAoXNbNݒ
#if (TARGET_BOARD & SAMD21_ALL)
	_reg(GCLK, CLKCTRL) =
			_val(GCLK, CLKCTRL, ID,  PWM_PCH)  |
			_val(GCLK, CLKCTRL, GEN, PWM_GCLK) |
			_val(GCLK, CLKCTRL, CLKEN, 1) ;
#else
	_reg(GCLK, PCHCTRL)[PWM_PCH] =
			_val(GCLK, PCHCTRL, GEN, PWM_GCLK) |
			_val(GCLK, PCHCTRL, CHEN, 1) ;
#endif
	PWM_APB_EN();								//oXNbNJn

	//|[gݒA^C}ݒ͍ŏ͂Ȃ(ꕔ̃{[hŗOL).
#if (TARGET_BOARD & SAMC21_CAN5)
	PORT_mode_out(PWM_POW, 1);
	PORT_mode_hpower(PWM_POW);
#endif
}

//----------------------------------------------------------------------------
// PWMݒ.
int PWM_start(int freq, int nega) {
	if (nega < 0) invert = -1;
	else invert = 1;
	
	count_max = PWM_FREQUENCY / freq;
	if (count_max > 65535) count_max = 65535;
	_regTC(PWM_TC, CC)[0] = count_max -1;			//ݒ.
	_regTC(PWM_TC, CC)[1] = 0;						//0%.
	
#if (TARGET_BOARD & SAMD21_ALL)
	_regTC(PWM_TC, CTRLA) =
			_valTC(PWM_TC, CTRLA, PRESCALER, PWM_PREC) |				//ݒ.
			_valTC(PWM_TC, CTRLA, WAVEGEN, TC_CTRLA_WAVEGEN_MPWM_Val);	//샂[hݒ.
#else
	_putTC(PWM_TC, CTRLA, MODE, 0);
	_regTC(PWM_TC, WAVE) = TC_WAVE_WAVEGEN_MPWM;
#endif
	_setTC(PWM_TC, CTRLA, ENABLE, 1);
	PORT_peri(PWM_PIN, PWM_MAPPING);
	return count_max;
}

//----------------------------------------------------------------------------
// PWMo(JE^lڎw).
void PWM_out(int count) {
	if (count > count_max) count = count_max;
	if (count < 0) count = 0;
	if (invert == -1) count = count_max - count;
	_regTC(PWM_TC, CC)[1] = count;
}

//----------------------------------------------------------------------------
// PWMo(䗦w).
void PWM_ratio(float r) {
	PWM_out((int)(r * count_max + 0.5));
}

//============================================================================
// ^XNA又.
//============================================================================

//============================================================================
// [J֐.
//============================================================================

//============================================================================
// nh.
//============================================================================

//============================================================================
