//============================================================================
// SPI2^XN
//
// (c)2021 Micon-Giken
//============================================================================
#include "kernel.h"
#include "task_spi2.h"

//============================================================================
// `.
//============================================================================

//============================================================================
// vg^Cv.
//============================================================================

//============================================================================
// f[^.
//============================================================================

//============================================================================
// API֐.
//============================================================================

//---------------------------------------------------------------------
// SPIhCoE^XN.
void SPI2_init() {
	//ӗpNbNAoXNbNݒ.
#if (TARGET_BOARD & SAMD21_ALL)
	_reg(GCLK, CLKCTRL) =
			_val(GCLK, CLKCTRL, ID, SPI2_PCH) |
			_val(GCLK, CLKCTRL, GEN, SPI2_GCLK) |
			_val(GCLK, CLKCTRL, CLKEN, 1) ;
#else
	_reg(GCLK, PCHCTRL)[SPI2_PCH] =
			_val(GCLK, PCHCTRL, GEN, SPI2_GCLK) |
			_val(GCLK, PCHCTRL, CHEN, 1) ;
#endif
	SPI2_APB_EN();										//oXNbNJn.
	
	//|[gݒ.
//	PORT_mode_in(SPI2_DI);
	PORT_mode_out(SPI2_CS, 1);
	PORT_peri(SPI2_DO, SPI_MAPPING);
	PORT_peri(SPI2_SCK, SPI_MAPPING);
	PORT_peri(SPI2_DI, SPI_MAPPING);

	//SPIݒ.
	#define SPI_BAUD	6000000
	#if (UART_FREQUENCY / 2 / SPI_BAUD) > 0
	_regSP(SPI2_SP, BAUD) = UART_FREQUENCY / 2 / SPI_BAUD - 1;
	#else
	_regSP(SPI2_SP, BAUD) = 0;
	#endif
	
#if (TARGET_BOARD & SAMD21_PM1)
	_regSP(SPI2_SP, CTRLA) =
			_valSP(SPI2_SP, CTRLA, DORD, 0)	   |		//MSB first.
			_valSP(SPI2_SP, CTRLA, CPOL, 0)	   |		//SCK is Positive.
			_valSP(SPI2_SP, CTRLA, CPHA, 1)	   |		//Rising change, Falling sample.
			_valSP(SPI2_SP, CTRLA, FORM, 0)	   |		//SPI mode(without ADDR).
			_valSP(SPI2_SP, CTRLA, DIPO, 0x03)  |		//M|[g.
			_valSP(SPI2_SP, CTRLA, DOPO, 0x00)  |		//M|[g.
#else
	_regSP(SPI2_SP, CTRLA) =
			_valSP(SPI2_SP, CTRLA, DORD, 0)	   |		//MSB first.
			_valSP(SPI2_SP, CTRLA, CPOL, 1)	   |		//SCK is Negative.
			_valSP(SPI2_SP, CTRLA, CPHA, 1)	   |		//Falling change, Rising sample.
			_valSP(SPI2_SP, CTRLA, FORM, 0)	   |		//SPI mode(without ADDR).
			_valSP(SPI2_SP, CTRLA, DIPO, 0x03)  |		//M|[g(_~[).
			_valSP(SPI2_SP, CTRLA, DOPO, 0x00)  |		//M|[g.
#endif
			_valSP(SPI2_SP, CTRLA, MODE, 0x03)  ;		//master[h.
	_setSP(SPI2_SP, CTRLB, RXEN, 1);					//MJn.
	_setSP(SPI2_SP, CTRLA, ENABLE, 1);					//Jn.

//	NVIC_set_priority(SPI_IRQ, 192);					//NVICDx192.
//	NVIC_enable_irq(SPI_IRQ);							//NVIC.
	_regSP(SPI2_SP, INTENSET) = SPI2_TX_END;				//M݃Cl[u.
	_regSP(SPI2_SP, INTENSET) = SPI2_RX_END;				//M݃Cl[u.

//	start_task(SPI_taskid, SPI_init1);
}

//============================================================================
// ^XNA又.
//============================================================================

//============================================================================
// [J֐.
//============================================================================

//----------------------------------------------------------------------------
// SPIM.
void SPI2_trx(uchar* tp, uchar* rp, int n) {
	int i;
	
	PORT_outclr(SPI2_CS);
	if (rp != NULL) {
		*rp = _regSP(SPI2_SP, DATA);
	}
	else //_regSP(SPI_SP, INTFLAG) = SPI_RX_END;
	_regSP(SPI2_SP, INTFLAG) = SPI2_RX_END;				//M݃NA.
	
	for (i = 0; i < n; i++) {
		//f[^o(݃tO̓NA).
		if (tp == NULL)	_regSP(SPI2_SP, DATA) = 0xff;
		else			_regSP(SPI2_SP, DATA) = *tp++;
		
		//M݃tO҂.
		while(!(_regSP(SPI2_SP, INTFLAG) & SPI2_TX_END));
		//M݃tO҂.
		while(!(_regSP(SPI2_SP, INTFLAG) & SPI2_RX_END));
		
		if (rp != NULL) {
			*rp++ = _regSP(SPI2_SP, DATA);
		}
		else //_regSP(SPI_SP, INTFLAG) = SPI_RX_END;
		_regSP(SPI2_SP, INTFLAG) = SPI2_RX_END;				//M݃NA.
	}

	PORT_outset(SPI2_CS);
}

//============================================================================
// nh.
//============================================================================


//============================================================================
