//============================================================================
// foCXi|[gAӁjt`pwb_.
//
// (c)2019-2022 Micon-Giken
//============================================================================
#ifndef DEVICE_H
#define	DEVICE_H

#include <xc.h>
#undef char
#undef short
#undef int
#undef long
#undef signed
#undef unsigned

//============================================================================
// LCDI.
//============================================================================
#include "board.h"
#define TARGET_BOARD	SAMC21_CAN5
#define TARGET_LCD		LCD_TYPE_SG12864
//#define TARGET_LCD		LCD_TYPE_AQM1248

//============================================================================
// ^C~O{`.
//============================================================================
#define VDD_VOLTAGE		(5)				// d 5܂3w [V].
#define XOSC_FREQUENCY	(0)				// OUo͎g [Hz] :gpȂƂ0ɐݒ肷邱.
#define OSC_FREQUENCY	(24000000)		// UNbNo͐ݒ [Hz].
#define O32_FREQUENCY	(32768)			// 32KNbNo͐ݒ [Hz] :gpȂƂ0ɐݒ肷邱.
#define X32_FREQUENCY	(32768)			// O32KNbNo͐ݒ [Hz] :gpȂƂ0ɐݒ肷邱.
#define VCO_FREQUENCY	(48000000)		// PLLUg [Hz].
#define PLL_FREQUENCY	(24000000)		// PLLo͎g [Hz] :gpȂƂ0ɐݒ肷邱.

#define CPU_CLOCK_SRC	_src(OSC48M)	// CPUNbNE\[Xݒ.
#define CPU_FREQUENCY	(24000000)		// CPUNbNݒ [Hz].
#define BASE_CLOCK_SRC	_src(DPLL96M)	// x[XE^C}pNbNE\[Xݒ.
#define BASE_FREQUENCY	(1000000)		// x[XE^C}pNbNg [Hz].
#define UART_CLOCK_SRC	_src(DPLL96M)	// UARTpNbNE\[Xݒ.
#define UART_FREQUENCY	(12000000)		// UARTpNbNg [Hz].
#define BEEP_CLOCK_SRC	_src(DPLL96M)	// BEEPpNbNE\[Xݒ.
#define BEEP_FREQUENCY	(12000000)		// fBpNbNg [Hz].
#define CAN_CLOCK_SRC	_src(DPLL96M)	// CANNbNE\[Xݒ.
#define CAN_FREQUENCY	(8000000)		// CANpNbNg [Hz].
#define PWM_FREQUENCY	(12000000)		// PWMpNbNg [Hz].
#define TASK_PERIOD		(5)				// ^XNpBmsPʁB1, 2, 5, 10̂ꂩ.
#define TASK_WINDOW		(80)			// ^XNĎԁBɑ΂1%PʂŎwB1-100̂ꂩ.
#define CLOCKS_PER_SEC	(1000/TASK_PERIOD)

//============================================================================
// \[X蓖.
//============================================================================
/*
 * GCLK0		CPU,oXp(CPU_FREQUENCYŎw).
 * GCLK1		NbNo͊mFpieXgpAPA15ój(ver1.xx܂Ŗgp).
 * GCLK2		1MHzo͗p(BASE_FREQUENCY)iTC0,TC2pj(ADC0łgp).
 * GCLK3		UARTp6̔{MHz(UART_FREQUENCYŎw).
 * GCLK4		CANp8̔{MHz(CAN_FREQUENCYŎw).
 * GCLK5		fBp(BEEP_FREQUENCYŎw).
 * GCLK6		.
 * GCLK7		(ver1.xx܂ŃNbNo͊mFp, PB13o).
 * GCLK8		.
 * 
 * SERCOM0		SPIpiSPIڑLCDpɗ\j.
 * SERCOM1		USB-VAϊp.
 * SERCOM2		I2CpiEEPROMpj.
 * SERCOM3		RS-485p.
 * SERCOM4		.
 * SERCOM5		sgpi݃\[X^XN񊄍݂ɗpj.
 * 
 * TC0			PWMiLED, PB13ój(ver1.xx܂Œ^C}).
 * TC1			.
 * TC2			^C}iCP0:, CP1:^XNĎԁj.
 * TC3			.
 * TC4			BEEPp`góAfBo.
 * 
 * TCC0			.
 * TCC1			.
 * TCC2			pXvp(\).
 * 
 * CAN0			gp.
 * CAN1			gp.
 * 
 * 
 */

//============================================================================
// J[l^C}ix[XE^C}j.
//============================================================================
#define kernel_timer		TC2_Handler
#define BTIMER_IRQ			TC2_IRQn
#define BTIMER_PERIOD		(BASE_FREQUENCY / CLOCKS_PER_SEC - 1)
#define BTIMER_WINDOW		(((BASE_FREQUENCY / CLOCKS_PER_SEC) * TASK_WINDOW) / 100)

#define BTIMER_GCLK			(2)
#define BTIMER_PCH			(31)
#define BTIMER_APB_EN()		_set(MCLK, APBCMASK, TC2, 1)

#define BTIMER_TC			TC2_REGS->COUNT16
#define BTIMER_PERIOD_INT	_valTC(BTIMER_TC, INTFLAG, MC0, 1)
#define BTIMER_WINDOW_INT	_valTC(BTIMER_TC, INTFLAG, MC1, 1)
//============================================================================
// 񊄍.
//============================================================================
#define kernel_schedule		SERCOM5_Handler
#define SCHEDULE_IRQ		SERCOM5_IRQn

//============================================================================
// NbNEj^.
//============================================================================
//
#define CLOCK_GCLK		(1)
#define CLOCK_PIN		(PIN_PA15)
#define CLOCK_MAPPING	PORT_MAP_GCLK_CMP

//============================================================================
// LED\.
//============================================================================
#define LED0_PIN		(PIN_PA10)
#define LED1_PIN		(PIN_PA11)
#define LED2_PIN		(PIN_PB10)
#define LED3_PIN		(PIN_PB11)

//============================================================================
// XCb`.
//============================================================================
#if TARGET_BOARD == SAMC21_CAN5
#define PUSH1_PIN		(PIN_PB06)
#define PUSH2_PIN		(PIN_PB07)
#define PUSH3_PIN		(PIN_PB05)
#define PUSH4_PIN		(PIN_PB04)

#define DIPSW1_PIN		(PIN_PB03)
#define DIPSW2_PIN		(PIN_PB02)
#define DIPSW3_PIN		(PIN_PB01)
#define DIPSW4_PIN		(PIN_PB00)
#else
#define PUSH1_PIN		(PIN_PB06)
#define PUSH2_PIN		(PIN_PB07)
#define PUSH3_PIN		(PIN_PB08)
#define PUSH4_PIN		(PIN_PB09)

#define DIPSW1_PIN		(PIN_PB05)
#define DIPSW2_PIN		(PIN_PB04)
#define DIPSW3_PIN		(PIN_PA03)
#define DIPSW4_PIN		(PIN_PA02)
#endif

//============================================================================
// uU[AfBo.
//============================================================================
#define BEEP_PIN		(PIN_PA18)
#define BEEP_MAPPING	PORT_MAP_TC_TCC
#define BEEP_GCLK		(5)
#define BEEP_PCH		(32)
#define BEEP_APB_EN()	_set(MCLK, APBCMASK, TC4, 1);

#define BEEP_TC			TC4_REGS->COUNT16

//============================================================================
// PWMo.
//============================================================================
#define PWM_PIN			(PIN_PB13)
#define PWM_POW			(PIN_PA14)
#define PWM_MAPPING		PORT_MAP_TC_TCC
#define PWM_GCLK		(5)
#define PWM_PCH			(30)	//TC0,TC1
//#define PWM_APB_EN()	_set(PM, APBCMASK, TC0, 1);		// for SAMD21
#define PWM_APB_EN()	_set(MCLK, APBCMASK, TC0, 1);

#define PWM_TC			TC0_REGS->COUNT16

//============================================================================
// AiOM.
//============================================================================
#define AD_APB_EN()			 _set(MCLK, APBCMASK, ADC0, 1)
#define AD_PCH				(33)
#define AD_GCLK				(2)
#define AD_AD				ADC0_REGS
#if 0
#define AD1_APB_EN()		_set(MCLK, APBCMASK, ADC1, 1)
#define AD1_PCH				(34)
#define AD1_GCLK			(2)
#define AD1_AD				ADC1_REGS
#endif

#define AD_RESRDY_INT		_valAD(AD_AD, INTFLAG, RESRDY, 1)

//============================================================================
// UARTʐM.
//============================================================================
#define UART_Handler		SERCOM1_Handler
#define UART_IRQ			SERCOM1_IRQn

#define UART_TX_PIN			(PIN_PA16)
#define UART_RX_PIN			(PIN_PA17)
#define UART_MAPPING		PORT_MAP_COM

#define UART_GCLK			(3) //(GCLK_PCHCTRL_GEN_GCLK3)
#define UART_PCH			(20)//(SERCOM1_GCLK_ID_CORE)
#define UART_APB_EN()		_set(MCLK, APBCMASK, SERCOM1, 1)

#define UART_SC				SERCOM1_REGS->USART_INT
#define UART_TX_INT			_valSC(UART_SC, INTFLAG, DRE, 1)
#define UART_RX_INT			_valSC(UART_SC, INTFLAG, RXC, 1)

//============================================================================
// RS485ʐM.
//============================================================================
#define RS485_Handler		SERCOM3_Handler
#define RS485_IRQ			SERCOM3_IRQn

#define RS485_TX_PIN		(PIN_PA22)
#define RS485_RX_PIN		(PIN_PA23)
#define RS485_EN_PIN		(PIN_PA24)
#define RS485_MAPPING		PORT_MAP_COM

#define RS485_GCLK			(3)
#define RS485_PCH			(22)	//(SERCOM3_GCLK_ID_CORE)
#define RS485_APB_EN()		_set(MCLK, APBCMASK, SERCOM3, 1)

#define RS485_SC			 SERCOM3_REGS->USART_INT
#define RS485_TX_INT		_valSC(RS485_SC, INTFLAG, DRE, 1)
#define RS485_RX_INT		_valSC(RS485_SC, INTFLAG, RXC, 1)

//============================================================================
// I2CʐM(EEP܂).
//============================================================================
#define I2C_Handler		SERCOM2_Handler
#define I2C_IRQ			SERCOM2_IRQn

#define I2C_SDA_PIN		(PIN_PA12)
#define I2C_SCL_PIN		(PIN_PA13)
#define I2C_MAPPING		PORT_MAP_COM

#define I2C_GCLK		(3)
#define I2C_PCH			(21)
#define I2C_APB_EN()	_set(MCLK, APBCMASK, SERCOM2, 1)

#define I2C_IM			 SERCOM2_REGS->I2CM
#define I2C_MB_INT		_valIM(I2C_IM, INTFLAG, MB, 1)
#define I2C_SB_INT		_valIM(I2C_IM, INTFLAG, SB, 1)
#define I2C_ERROR_INT	_valIM(I2C_IM, INTFLAG, ERROR, 1)

#define I2C_ADDR_EEPROM	(0x50)		// EEPROMI2CAhX(7bit).
#define I2C_PAGE_SIZE	256			// EEPROMy[WTCY.

//============================================================================
// CANʐM.
//============================================================================
//
#define CAN_MAPPING			PORT_MAP_CAN
#define CAN0_TX_PIN			(PIN_PB22)
#define CAN0_RX_PIN			(PIN_PB23)
#define CAN1_TX_PIN			(PIN_PB14)
#define CAN1_RX_PIN			(PIN_PB15)

#define CAN_GCLK			(4)
#define CAN0_PCH			(26)
#define CAN1_PCH			(27)
#define CAN0_AHB_EN()		_set(MCLK, AHBMASK, CAN0, 1)
#define CAN1_AHB_EN()		_set(MCLK, AHBMASK, CAN1, 1)

#define CAN0				CAN0_REGS
#define CAN1				CAN1_REGS

//============================================================================
// LCD\.
//============================================================================
#if TARGET_LCD == LCD_TYPE_SG12864
#define LCD_RST			(PIN_PB31)
#define LCD_CS2			(PIN_PB30)
#define LCD_CS1			(PIN_PA28)
#define LCD_D7			(PIN_PA27)
#define LCD_D6			(PIN_PA25)
#define LCD_D5			(PIN_PA21)
#define LCD_D4			(PIN_PA20)
#define LCD_D3			(PIN_PB17)
#define LCD_D2			(PIN_PB16)
#define LCD_D1			(PIN_PA19)
#define LCD_D0			(PIN_PB12)
#define LCD_E			(PIN_PA09)
#define LCD_DI			(PIN_PA08)
#endif

#if TARGET_LCD == LCD_TYPE_AQM1248
#define LCD_DO			(PIN_PA08)
#define LCD_SCK			(PIN_PA09)
#define LCD_RS			(PIN_PA27)
#define LCD_CS			(PIN_PA28)
#if 1
#define SPI_Handler		SERCOM0_Handler
#define SPI_IRQ			SERCOM0_IRQn
#define SPI_MAPPING		PORT_MAP_COM
#define SPI_PCH			(19)//(SERCOM0_GCLK_ID_CORE)
#define SPI_APB_EN()	_set(MCLK, APBCMASK, SERCOM0, 1)
#define SPI_SP			SERCOM0_REGS->SPIM
#else
#define SPI_Handler		SERCOM2_Handler
#define SPI_IRQ			SERCOM2_IRQn
#define SPI_MAPPING		PORT_MAP_COMALT
#define SPI_PCH			(21)//(SERCOM2_GCLK_ID_CORE)
#define SPI_APB_EN()	_set(MCLK, APBCMASK, SERCOM2, 1)
#define SPI_SP			SERCOM2_REGS->SPIM
#endif

#define SPI_GCLK		(3) //(GCLK_PCHCTRL_GEN_GCLK3)

#define SPI_TX_END		_valSP(SPI_SP, INTFLAG, TXC, 1)
#endif

//============================================================================
// Ӌ@\}bsO`.
//============================================================================
#if TARGET_BOARD & SAMC21_ALL
enum PORT_MAPPING {
	PORT_MAP_EXINT,		//A
	PORT_MAP_ADC,		//B
	PORT_MAP_COM,		//C
	PORT_MAP_COMALT,	//D
	PORT_MAP_TC_TCC,	//E
	PORT_MAP_TCC,		//F
	PORT_MAP_CAN,		//G
	PORT_MAP_GCLK_CMP,	//H
	PORT_MAP_CCL,		//I
};

#elif TARGET_BOARD & SAMD21_ALL
enum PORT_MAPPING {
	PORT_MAP_EXINT,		//A
	PORT_MAP_ADC,		//B
	PORT_MAP_COM,		//C
	PORT_MAP_COMALT,	//D
	PORT_MAP_TC_TCC,	//E
	PORT_MAP_TCC,		//F
	PORT_MAP_USBI2S,	//G
	PORT_MAP_GCLK_CMP,	//H
};

#elif TARGET_BOARD & SAME54_ALL
enum PORT_MAPPING {
	PORT_MAP_EXINT,		//A
	PORT_MAP_ADC,		//B
	PORT_MAP_COM,		//C
	PORT_MAP_COMALT,	//D
	PORT_MAP_TC,		//E
	PORT_MAP_TCC,		//F
	PORT_MAP_TCC_PDEC,	//G
	PORT_MAP_QSP_CAN1_USB,	//H
	PORT_MAP_SDHC_CAN0,	//I
	PORT_MAP_I2S,		//J
	PORT_MAP_PCC,		//K
	PORT_MAP_GMAC,		//L
	PORT_MAP_GCLK_CMP,	//M
	PORT_MAP_CCL,		//N
};

#endif
//============================================================================
// API֐.
//============================================================================
void	DEVICE_init(void);		// NbNA|[g.
int		DEVICE_stack(void);	// X^bNʎ擾 (߂l:oCgP(ŏl256)).
int		DEVICE_det_wdt(void);	// EIb`hbOEZbgo(߂lEOFȂ猟o).

//============================================================================
#endif	/* DEVICE_H */
